#include "perform_front_propagation_3d.h"
#include "fib.h"
#include "fibpriv.h"
#include "iostream"
#include "fstream"
#include "iomanip"

#include"parameters.h"
using namespace std;








void perform_front_propagation_3d( T_callback_intert_node callback_insert_node ); 

void load_regions_function(char filename_txt_format[],  short regions_array[], parameters param);

void sphere(short regions_array[], parameters param);

void one_region(short regions_array[], parameters &param);

void get_boundary(short regions_array[], long grad0[], parameters param);

/////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 //this function will throw out all the region information
 void set_all_regions_to_one(short regions_array[], parameters param);

 /////////////////////////////////////////////////////////////////////////////

 void remove_singletons(short regions_array[], parameters param);
 void remove_doubletons(short regions_array[], parameters param);
 void remove_binytons(short regions_array[], parameters param);
 void remove_doubletonsr(short regions_array[], parameters param);

 ///////////////////////////////////////////////////////////////////////////////////

void pre_process_regions(short regions_array[], parameters param);
void zoom_out(short regions_array[], short new_regions_array[], parameters &param);


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/* note the that the files config.h, fib.h, fibpriv.h, image2d.h, image3d.h, perform_fast_propogation, fib.cpp, image2d.cpp
image3d.cpp, and perform_front_propogation.cpp are taken from an online free program exchange thing.  the program runs
unusually slowly and may need to be redone if we eventually decide to use the fast marcing method for a final product.
*/
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////


int main( int argc, char *argv[])
{

	/*
if( argc < 9 )
    {
   // std::cerr << argc <<std::endl;
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " region_text_file output_levelset_file size_x size_y size_z region_text_file_output zoom level(1,2,or3) compute_ls (0false or 1true)" << std::endl;;
    //std::cerr << " outputImageFile " 
    return EXIT_FAILURE;
    }
	*/

if( argc < 5 )
    {
   // std::cerr << argc <<std::endl;
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " region_file_in parameters_file region_file_out ls_file_out" << std::endl;
    //std::cerr << " outputImageFile " 
    return EXIT_FAILURE;
    }



	parameters param;
	//param.initialize_parameters(argv[1],argv[2],std::atoi(argv[3]),std::atoi(argv[4]),std::atoi(argv[5]),argv[6], std::atoi(argv[7]), std::atoi(argv[8]));

	param.initialize_parameters(argv[1],argv[2],argv[3],argv[4]);



	short *regions_array; regions_array = new short[param.size3D];

	if(param.sphere == false){
		load_regions_function(param.region_file_in, regions_array, param);
	}

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//for(long n=0;n<param.size3D;n++){
	//	if(regions_array[n] == 1){
	//		regions_array[n] = 0;
	//	}
	//}

	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	//set_all_regions_to_one(regions_array, param);

	if(param.sphere == true){
		sphere(regions_array, param);
		cout << "sphere loaded" << endl;
	}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//this part of the code selects one region


	if(param.one_region == true){

		long old_size1D_x = param.size1D_x;
		long old_size1D_y = param.size1D_y;
		long old_size1D_z = param.size1D_z;

		long x_min = param.size1D_x;
		long x_max = -1;
		long y_min = param.size1D_y;
		long y_max = -1;
		long z_min = param.size1D_z;
		long z_max = -1;


		for(long ii=0;ii<param.size1D_x;ii++){
			for(long jj=0;jj<param.size1D_y;jj++){
				for(long kk=0;kk<param.size1D_z;kk++){

					if(regions_array_(ii,jj,kk) == param.single_region){

						if(ii < x_min){
							x_min = ii;
						}
						if(ii > x_max){
							x_max = ii;
						}
						if(jj < y_min){
							y_min = jj;
						}
						if(jj > y_max){
							y_max = jj;
						}
						if(kk < z_min){
							z_min = kk;
						}
						if(kk > z_max){
							z_max = kk;
						}
						regions_array_(ii,jj,kk) = param.single_region;

					}else{

						regions_array_(ii,jj,kk)=0;
					}

				}
			}
		}

		
		x_min = x_min - 30;
		y_min = y_min - 30;
		z_min = z_min - 30;
		x_max = x_max + 30;
		y_max = y_max + 30;
		z_max = z_max + 30;



		//or specify x_min, x_max, etc here

		if(param.specify_min_max == true){

			x_min = param.x_min;
			x_max = param.x_max;
			y_min = param.y_min;
			y_max = param.y_max;
			z_min = param.z_min;
			z_max = param.z_max;

		};

		cout << "x_min is" << x_min << endl;
		cout << "y_min is" << y_min << endl;
		cout << "z_min is" << z_min << endl;
		cout << "x_max is" << x_max << endl;
		cout << "y_max is" << y_max << endl;
		cout << "z_max is" << z_max << endl;

		param.change_size((x_max - x_min), (y_max - y_min), (z_max - z_min));

		short *temp_array; temp_array = new short[param.size3D];

		long ii_p, jj_p, kk_p, old_index;
		for(long ii=0;ii<param.size1D_x;ii++){
			for(long jj=0;jj<param.size1D_y;jj++){
				for(long kk=0;kk<param.size1D_z;kk++){
		
					ii_p=ii+x_min;
					jj_p=jj+y_min;
					kk_p=kk+z_min;

					old_index = ii_p+old_size1D_x*jj_p+old_size1D_x*old_size1D_y*kk_p;

					temp_array_(ii,jj,kk) = regions_array[old_index];

				}
			}
		}

		
		delete [] regions_array;
		regions_array = new short[param.size3D];

		for(long ii=0;ii<param.size1D_x;ii++){
			for(long jj=0;jj<param.size1D_y;jj++){
				for(long kk=0;kk<param.size1D_z;kk++){

					regions_array_(ii,jj,kk) = temp_array_(ii,jj,kk);

				}
			}
		}


		delete [] temp_array;



		ofstream out_stream;

		out_stream.open(param.filename_one_region);
		for(long zz=0;zz<param.size3D;zz++){
			out_stream << regions_array[zz] << " " ;
		};
		out_stream.close();
		cout << "one region printed" << endl;

		




	
		cout << "one region selected" << endl;

	}

	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	//making image divisible by 4 in all directions

	short *exp_regions_array;

	long new_img_size_x; new_img_size_x = param.size1D_x;
	long new_img_size_y; new_img_size_y = param.size1D_y;
	long new_img_size_z; new_img_size_z = param.size1D_z;

	if( (param.size1D_x % 2) == 1 ){
		new_img_size_x = new_img_size_x + 1;
	}
	if( (new_img_size_x % 4) == 2 ){
		new_img_size_x = new_img_size_x + 2;
	}

	if( (param.size1D_y % 2) == 1 ){
		new_img_size_y = new_img_size_y + 1;
	}
	if( (new_img_size_y % 4) == 2 ){
		new_img_size_y = new_img_size_y + 2;
	}

	if( (param.size1D_z % 2) == 1 ){
		new_img_size_z = new_img_size_z + 1;
	}
	if( (new_img_size_z % 4) == 2 ){
		new_img_size_z = new_img_size_z + 2;
	}
	
	long new_image_size; new_image_size = new_img_size_x*new_img_size_y*new_img_size_z;

	exp_regions_array = new short[new_image_size];

	long index, indexa, indexb;

	for(long ii=0;ii<new_img_size_x;ii++){
		for(long jj=0;jj<new_img_size_y;jj++){
			for(long kk=0;kk<new_img_size_z;kk++){

				indexa = ii+jj*new_img_size_x+kk*new_img_size_x*new_img_size_y;
				indexb = ii + (param.size1D_x)*jj + (param.size1D_x)*(param.size1D_y)*kk;

				if( ( ii < param.size1D_x ) && ( jj < param.size1D_y ) && ( kk < param.size1D_z ) ){

					exp_regions_array[indexa] = regions_array[indexb];

				}else{

					exp_regions_array[indexa] = 0;

				}

			}
		}
	}

	param.size1D_x = new_img_size_x;
	param.size1D_y = new_img_size_y;
	param.size1D_z = new_img_size_z;
	param.size3D = param.size1D_x*param.size1D_y*param.size1D_z;

	delete [] regions_array;
	regions_array = new short[param.size3D];
	for(long zz=0; zz<param.size3D; zz++){
		regions_array[zz] = exp_regions_array[zz];
	}
	delete [] exp_regions_array;








	









///


	pre_process_regions(regions_array, param);

	remove_singletons(regions_array, param);
		remove_singletons(regions_array, param);

		remove_doubletons(regions_array, param);
		remove_doubletons(regions_array, param);
		remove_doubletons(regions_array, param);
		remove_doubletons(regions_array, param);

		remove_binytons(regions_array, param);
		remove_binytons(regions_array, param);
		remove_binytons(regions_array, param);
		remove_binytons(regions_array, param);

		remove_doubletons(regions_array, param);
		remove_doubletons(regions_array, param);
		remove_doubletons(regions_array, param);
		remove_doubletons(regions_array, param);

		remove_binytons(regions_array, param);
		remove_binytons(regions_array, param);
		remove_binytons(regions_array, param);
		remove_binytons(regions_array, param);


	///////////////////////////////////////
	//zooming in or out

	short *new_regions_array; 

	if( (param.zoom_level == 2) || (param.zoom_level == 3) ){

	new_regions_array = new short[param.size3D/8];
	zoom_out(regions_array, new_regions_array, param);

	delete [] regions_array;
	regions_array = new short[param.size3D];
	for(long zz=0; zz<param.size3D; zz++){
		regions_array[zz] = new_regions_array[zz];
	}
	delete [] new_regions_array;

	cout << "zoomed once" << endl;

	}

	

	if( param.zoom_level == 3 ){

	new_regions_array = new short[param.size3D/8];
	zoom_out(regions_array, new_regions_array, param);

	delete [] regions_array;
	regions_array = new short[param.size3D];
	for(long zz=0; zz<param.size3D; zz++){
		regions_array[zz] = new_regions_array[zz];
	}
	delete [] new_regions_array;

	cout << "zoomed twice" << endl;

	}

	






	/////////////////////////////////////


	//////////////////////////////////////////////////////////////////////////////////////////////////

	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	//extending the size of the image

	cout << "new size1D_x is " << param.size1D_x+16 << endl;
	cout << "new size1D_y is " << param.size1D_y+16 << endl;
	cout << "new size1D_z is " << param.size1D_z+16 << endl;

	

	short *temp_regions_array; temp_regions_array = new short[(param.size1D_x+16)*(param.size1D_y+16)*(param.size1D_z+16)];

	for(long i=0;i<param.size1D_x+16;i++){
		for(long j=0;j<param.size1D_y+16;j++){
			for(long k=0;k<param.size1D_z+16;k++){

				index = i + (param.size1D_x+16)*j + (param.size1D_x+16)*(param.size1D_y+16)*k;
				temp_regions_array[index] = 0;

			}
		}
	}

	for(long i=0;i<param.size1D_x;i++){
		for(long j=0;j<param.size1D_y;j++){
			for(long k=0;k<param.size1D_z;k++){

				indexa = (i+8) + (param.size1D_x+16)*(j+8) + (param.size1D_x+16)*(param.size1D_y+16)*(k+8);
				indexb = i + (param.size1D_x)*j + (param.size1D_x)*(param.size1D_y)*k;

				temp_regions_array[indexa] = regions_array[indexb];

			}
		}
	}

	delete [] regions_array;
	param.size1D_x = param.size1D_x+16;
	param.size1D_y = param.size1D_y+16;
	param.size1D_z = param.size1D_z+16;
	param.size3D = param.size1D_x*param.size1D_y*param.size1D_z;

	regions_array = new short[param.size3D];
	for(long zz=0; zz<param.size3D; zz++){
		regions_array[zz] = temp_regions_array[zz];
	}

	delete [] temp_regions_array;

		

		



ofstream out_stream;

	out_stream.open(param.region_file_out);
		for(long zz=0;zz<param.size3D;zz++){
	out_stream << regions_array[zz] << " " ;
	};
	out_stream.close();


	if(param.compute_ls == true){


	//here the gradient norm of regions_array is computed.  If it is non-zero it is set to 1 and otherwise remains 0. This is to get a quick an easy
	//representation of the boundary
	//get_boundary also computes the number of edge points

	nb_start_points = 0;

	long *grad0; grad0 = new long[param.size3D*8];
	get_boundary(regions_array, grad0, param);


////
//putting the boundary information in the correct form for the program to run below



start_points = new double[3*nb_start_points];
long counter = 0;

for(long kk=1; kk<(2*param.size1D_z-1);kk++){
	for(long jj=1;jj<(2*param.size1D_y-1);jj++){
		for(long ii=1;ii<(2*param.size1D_x-1);ii++){
			if(grad0_(ii,jj,kk) == 1){			
				start_points[counter] = ii;
				start_points[counter+1] = jj;
				start_points[counter+2] = kk;
				counter = counter + 3;
			};
		};
	};
};


cout << "start points found" << endl;

delete [] regions_array;
delete [] grad0;

//other stuff needs to be put in the correct form for the program to run

n=param.size1D_x*2;
p=param.size1D_y*2;
q=param.size1D_z*2;


D = new double[param.size3D*8];
S = new double[param.size3D*8];
W = new double[1];



for(long u=0; u<1; u++){
	W[u] = 1.0/double(param.size1D_x);
};


Q = new double[param.size3D*8];


nb_iter_max = 10000000000;

cout << "fast marching method started" << endl;

perform_front_propagation_3d();

cout << "fast marching method finished" << endl;



//the level set is printed to a text file


if(param.zoom_level == 1){
out_stream.open(param.ls_file_out);
for(long zz=0;zz<(param.size3D*8);zz++){
	out_stream << D[zz] << " " ;
};
out_stream.close();
cout << "level set printed" << endl;
}

if(param.zoom_level == 2){
out_stream.open(param.ls_file_out);
for(long zz=0;zz<(param.size3D*8);zz++){
	out_stream << 2*D[zz] << " " ;
};
out_stream.close();
cout << "level set printed" << endl;
}

if(param.zoom_level == 3){
out_stream.open(param.ls_file_out);
for(long zz=0;zz<(param.size3D*8);zz++){
	out_stream << 4*D[zz] << " " ;
};
out_stream.close();
cout << "level set printed" << endl;
}

// a slice of the level set is printed to a matlab file.  this is just to get a sense of whether the program worked

/*
double *slice; slice = new double[param.size1D_x*param.size1D_y];

long index1;
long index2;
long k = long(floor(param.size1D_z/2.0));

	for(long j=0;j<param.size1D_y;j++){
		for(long i=0;i<param.size1D_x;i++){
			index1 = i+param.size1D_x*j + param.size1D_y*param.size1D_x*k;
			index2 = i+param.size1D_x*j;
			slice[index2] =  D[index1];
		};
	};



out_stream.open("slice_test.m");

out_stream << "slice_test=zeros(" <<(param.size1D_x) << "," << (param.size1D_y) << ");" << endl;

for(long j=0;j<(param.size1D_y);j++){
		for(long i=0;i<(param.size1D_x);i++){
			index2 = i+param.size1D_x*j;
			out_stream << "slice_test("<<(i+1) <<","<<(j+1)<<") = " << slice[index2] <<";"<< endl;
		};
	};

out_stream << "contour(slice_test)" << endl;


	
cout << "slice printed" << endl;


//printing regions




cout << param.size3D << endl;
*/

}

}
