// remove0.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

////////////////////////////////////////////////////

void get_sizes(char filename_node[], char filename_ele[], short zl, parameters &param);
void get_tbd_size(char tbd_file[], parameters &param, short zl);

void load_nodes(double nodes[], char filename_node[], short zl, parameters param);
void load_tets(long tets[], char filename_ele[], short zl, parameters param);

void load_tbd(char node_tbd_file[], long nodes_p1[], long nodes_p2[], short zl, parameters param);

void fix_nodes_and_tets(double nodes_z1_old[], double nodes_z2_old[], double nodes_z3_old[], double nodes_z1_new[], double nodes_z2_new[], double nodes_z3_new[],
						long tets_z1_old[], long tets_z2_old[], long tets_z3_old[], long tets_z1_new[], long tets_z2_new[], long tets_z3_new[],
						long nodes_p1_z1_old[], long nodes_p2_z1_old[], long nodes_p1_z2_old[], long nodes_p2_z2_old[],
						long nodes_p1_z1_new[], long nodes_p2_z1_new[], long nodes_p1_z2_new[], long nodes_p2_z2_new[],
						long nodes_p1_z3_old[], long nodes_p2_z3_old[], long nodes_p1_z3_new[], long nodes_p2_z3_new[],
						 float ls3[], float ls2[], float ls1[],
						short nodes_ok1[], parameters &param);

void output(double nodes[], long tets[], parameters param, short zl, char node_file[], char tet_file[]);
void output_tbd(long nodes_tbd_p1[], long nodes_tbd_p2[], char node_tbd_file[], short zl,  short nodes_ok1[], parameters param);

void load_signed_distance_function(char filename_txt_format[], float signed_dist_array[], parameters param, short zoom_level);



////////////////////////////////////////////////////


int main( int argc, char *argv[])
{

/*
	if( argc < 25 )
    {
   // std::cerr << argc <<std::endl;
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " node_file_z3 node_file_z2 node_file_z1 tet_file_z3 tet_file_z2 tet_file_z1 node_tbd_file_z3 node_tbd_file_z2 node_tbd_file_z1  node_file_z3_out node_file_z2_out node_file_z1_out tet_file_z3_out tet_file_z2_out tet_file_z1_out node_file_tbd_z3_out node_tbd_file_z2_out node_tbd_file_z1_out ls3_file ls2_file ls1_file size_x size_y size_z" << std::endl;;
    //std::cerr << " outputImageFile " 
    return EXIT_FAILURE;
    }
*/
	if( argc < 7 )
    {
   // std::cerr << argc <<std::endl;
    std::cerr << "Missing Parameters " << std::endl;
    std::cerr << "Usage: " << argv[0];
    std::cerr << " node_file_in  ele_file_in  node_file_out  ele_file_out  level_set_file  parameters_file" << std::endl;;
    //std::cerr << " outputImageFile " 
    return EXIT_FAILURE;
    }

	cout <<  "started" << endl;

	parameters param;
	//param.initialize(size1D_x, size1D_y, size1D_z);
	param.initialize(argv[6]);

	//long size1D_x = std::atoi(argv[22]);
	//long size1D_y = std::atoi(argv[23]);
	//long size1D_z = std::atoi(argv[24]);

	char ls3_file[4000];
	char ls2_file[4000];
	char ls1_file[4000];

	char node_file_z3[4000];
	char node_file_z2[4000];
	char node_file_z1[4000];

	char tet_file_z3[4000];
	char tet_file_z2[4000];
	char tet_file_z1[4000];

	char node_tbd_file_z3[4000];
	char node_tbd_file_z2[4000];
	char node_tbd_file_z1[4000];

	char node_file_z3_out[4000];
	char node_file_z2_out[4000];
	char node_file_z1_out[4000];

	char tet_file_z3_out[4000];
	char tet_file_z2_out[4000];
	char tet_file_z1_out[4000];

	char node_tbd_file_z3_out[4000];
	char node_tbd_file_z2_out[4000];
	char node_tbd_file_z1_out[4000];

	strcpy(ls3_file, "NA");
	strcpy(ls2_file, "NA");
	strcpy(ls1_file, argv[5]);

	strcpy(node_file_z3, "NA");
	strcpy(node_file_z2, "NA");
	strcpy(node_file_z1, argv[1]);

	strcpy(tet_file_z3, "NA");
	strcpy(tet_file_z2, "NA");
	strcpy(tet_file_z1, argv[2]);

	strcpy(node_tbd_file_z3, "NA");
	strcpy(node_tbd_file_z2, "NA");
	strcpy(node_tbd_file_z1, "NA");

	strcpy(node_file_z3_out, "NA");
	strcpy(node_file_z2_out, "NA");
	strcpy(node_file_z1_out, argv[3]);

	strcpy(tet_file_z3_out, "NA");
	strcpy(tet_file_z2_out, "NA");
	strcpy(tet_file_z1_out, argv[4]);

	strcpy(node_tbd_file_z3_out, "NA");
	strcpy(node_tbd_file_z2_out, "NA");
	strcpy(node_tbd_file_z1_out, "NA");

	double *nodes_z1_old;
	double *nodes_z2_old;
	double *nodes_z3_old;
	double *nodes_z1_new;
	double *nodes_z2_new;
	double *nodes_z3_new;

	long *tets_z1_old;
	long *tets_z2_old;
	long *tets_z3_old;
	long *tets_z1_new;
	long *tets_z2_new;
	long *tets_z3_new;


	long *nodes_p1_z1_old;
	long *nodes_p1_z2_old;
	long *nodes_p1_z3_old;

	long *nodes_p2_z1_old;
	long *nodes_p2_z2_old;
	long *nodes_p2_z3_old;

	long *nodes_p1_z1_new;
	long *nodes_p1_z2_new;
	long *nodes_p1_z3_new;

	long *nodes_p2_z1_new;
	long *nodes_p2_z2_new;
	long *nodes_p2_z3_new;

	

	//////////////////////////////////////////////////////////////////////////////////////////
	param.make_tbd = false;
	///////////////////////////////////////////////////////////////////////////////////////////

	//get_sizes(node_file_z3, tet_file_z3, 3, param);
	//get_sizes(node_file_z2, tet_file_z2, 2, param);
	get_sizes(node_file_z1, tet_file_z1, 1, param);

	cout << "old sizes found: nodes " << param.nodes_number_old[1] << " tets " << param.tets_number_old[1] << endl;

	nodes_z3_old = new double[3*param.nodes_number_old[3]];
	nodes_z2_old = new double[3*param.nodes_number_old[2]];
	nodes_z1_old = new double[3*param.nodes_number_old[1]];
	nodes_z3_new = new double[3*param.nodes_number_old[3]];
	nodes_z2_new = new double[3*param.nodes_number_old[2]];
	nodes_z1_new = new double[3*param.nodes_number_old[1]];

	tets_z3_old = new long[5*param.tets_number_old[3]];
	tets_z2_old = new long[5*param.tets_number_old[2]];
	tets_z1_old = new long[5*param.tets_number_old[1]];
	tets_z3_new = new long[5*param.tets_number_old[3]];
	tets_z2_new = new long[5*param.tets_number_old[2]];
	tets_z1_new = new long[5*param.tets_number_old[1]];

	//load_nodes(nodes_z3_old, node_file_z3, 3, param);
	//load_nodes(nodes_z2_old, node_file_z2, 2, param);
	load_nodes(nodes_z1_old, node_file_z1, 1, param);

	cout << "nodes loaded" << endl;

	//load_tets(tets_z3_old, tet_file_z3, 3, param);
	//load_tets(tets_z2_old, tet_file_z2, 2, param);
	load_tets(tets_z1_old, tet_file_z1, 1, param);

	cout << "tets loaded" << endl;

	float *ls1; ls1 = new float[param.size3Dl];
	float *ls2; ls2 = new float[param.size3Dl_z2];
	float *ls3; ls3 = new float[param.size3Dl_z3];
	load_signed_distance_function(ls1_file, ls1, param, 1);
	//load_signed_distance_function(ls2_file, ls2, param, 2);
	//load_signed_distance_function(ls3_file, ls3, param, 3);

	cout << "signed dist functions loaded " << endl;


	param.nodes_tbd_number_old[2] = param.nodes_number_old[2]-param.nodes_number_old[3];
	param.nodes_tbd_number_old[1] = param.nodes_number_old[1]-param.nodes_number_old[2];

	//get_tbd_size( node_tbd_file_z3, param, 3);

	param.nodes_number_old[4] = param.nodes_number_old[3] - param.nodes_tbd_number_old[3];

	nodes_p1_z3_old = new long[param.nodes_tbd_number_old[3]];
	nodes_p1_z2_old = new long[param.nodes_tbd_number_old[2]];
	nodes_p1_z1_old = new long[param.nodes_tbd_number_old[1]];

	nodes_p2_z3_old = new long[param.nodes_tbd_number_old[3]];
	nodes_p2_z2_old = new long[param.nodes_tbd_number_old[2]];
	nodes_p2_z1_old = new long[param.nodes_tbd_number_old[1]];

	nodes_p1_z3_new = new long[param.nodes_tbd_number_old[3]];
	nodes_p1_z2_new = new long[param.nodes_tbd_number_old[2]];
	nodes_p1_z1_new = new long[param.nodes_tbd_number_old[1]];

	nodes_p2_z3_new = new long[param.nodes_tbd_number_old[3]];
	nodes_p2_z2_new = new long[param.nodes_tbd_number_old[2]];
	nodes_p2_z1_new = new long[param.nodes_tbd_number_old[1]];

	//load_tbd(node_tbd_file_z3, nodes_p1_z3_old, nodes_p2_z3_old, 3, param);
	//load_tbd(node_tbd_file_z2, nodes_p1_z2_old, nodes_p2_z2_old, 2, param);
	//load_tbd(node_tbd_file_z1, nodes_p1_z1_old, nodes_p2_z1_old, 1, param);

	cout << "nodes tbd loaded" << endl;

	short *nodes_ok1;
	nodes_ok1 = new short[param.nodes_number_old[1]];

	fix_nodes_and_tets(nodes_z1_old, nodes_z2_old, nodes_z3_old, nodes_z1_new, nodes_z2_new, nodes_z3_new,
						tets_z1_old, tets_z2_old, tets_z3_old, tets_z1_new, tets_z2_new, tets_z3_new,
						nodes_p1_z1_old, nodes_p2_z1_old, nodes_p1_z2_old, nodes_p2_z2_old,
						nodes_p1_z1_new, nodes_p2_z1_new, nodes_p1_z2_new, nodes_p2_z2_new,
						nodes_p1_z3_old, nodes_p2_z3_old, nodes_p1_z3_new, nodes_p2_z3_new,
						ls3, ls2, ls1,
						nodes_ok1, param);

	cout << "removed 0s from nodes and tets" << endl;

	//output(nodes_z3_new, tets_z3_new, param, 3, node_file_z3_out, tet_file_z3_out);
	//output(nodes_z2_new, tets_z2_new, param, 2, node_file_z2_out, tet_file_z2_out);
	output(nodes_z1_new, tets_z1_new, param, 1, node_file_z1_out, tet_file_z1_out);

	cout << "output nodes and tets" << endl;

	//param.nodes_tbd_number_new[3] = param.nodes_number_new[3]-param.nodes_number_new[4];
	//param.nodes_tbd_number_new[2] = param.nodes_number_new[2]-param.nodes_number_new[3];
	//param.nodes_tbd_number_new[1] = param.nodes_number_new[1]-param.nodes_number_new[2];

	//if(param.make_tbd == true){
	//output_tbd(nodes_p1_z3_new, nodes_p2_z3_new, node_tbd_file_z3_out, 3, nodes_ok1, param);
	//output_tbd(nodes_p1_z2_new, nodes_p2_z2_new, node_tbd_file_z2_out, 2, nodes_ok1, param);
	//output_tbd(nodes_p1_z1_new, nodes_p2_z1_new, node_tbd_file_z1_out, 1, nodes_ok1, param);
	//cout << "output nodes tbd" << endl;
	//}

	


	return 0;
}

