#include "stdafx.h"
#include "sparse_matrix.h"

void vec_abs_max(float vec[], long &size, float &val){

	val = 0;
	float current_val;

	for(long n=0; n<size;n++){

		current_val = vec[n];

		if(vec[n] < 0){

			current_val = -current_val;

		}

		if( val < current_val ){

			val = current_val;

		}

	}

}	


void vec_trans_vec(float vec1[], float vec2[], long &size, float &val){

	float sum;
	sum=0;

	for(long n=0; n<size;n++){

		sum = sum + vec1[n]*vec2[n];

	}

	val = sum;

}


void sparse_matrix_m_vec(sparse_matrix &A, float vec_in[], float vec_out[]){


	long row_num;
	row_num = 0;

	long sm_entry;
	sm_entry = 0;

	for(long n=0; n<A.length;n++){
		vec_out[n] = 0;
	}

	//cout << sm.NZREN[0] << endl;
	//cout << sm.NZREN[1] << endl;

	for(long n=0; n<A.length; n++){

		//for(long m=0;m<A.NZREN[row_num];m++){
		for(long m=0;m<A.NZREN[n];m++){


			//vec_out[row_num] = vec_out[row_num] + A.e[sm_entry].val*vec_in[A.e[sm_entry].column];
			vec_out[n] += A.e[sm_entry].val*vec_in[A.e[sm_entry].column];

			//sm_entry = sm_entry + 1;
			sm_entry++;

		}

		//row_num = row_num + 1;

	}

}

void get_r0(float vec_b[], float vec_guess[], sparse_matrix &A, float vec_r0[], parameters &param){

	

	sparse_matrix_m_vec(A, vec_guess, param.vec_A_x0);

	for(long n=0;n<A.length;n++){

		vec_r0[n] = vec_b[n] - param.vec_A_x0[n];

	}


}

/*
void get_alpha_k(float vec_r_k[], float vec_p_k[], float vec_A_p_k[], long &size, float &alpha){

	float r_t_r;
	float p_A_p;


	vec_trans_vec(vec_r_k, vec_r_k, size, r_t_r);

	vec_trans_vec(vec_p_k, vec_A_p_k, size, p_A_p);

	alpha = r_t_r/p_A_p;

}
*/

void get_x_kp1(float vec_x_k[], float &alpha, float vec_p_k[], long &size){

	for(long n=0;n<size;n++){

		vec_x_k[n] += alpha*vec_p_k[n];

	}

}

void get_r_kp1(float vec_r_k[], float &alpha, float vec_A_p_k[], long &size){

	for(long n=0;n<size;n++){

		vec_r_k[n] -= alpha*vec_A_p_k[n];

	}

}

/*
void get_b_k(float vec_r_k[], float vec_r_kp1[], long &size, float &b_k){


	float r_t_r_kp1;
	float r_t_r_k;

	vec_trans_vec(vec_r_k, vec_r_k, size, r_t_r_k);

	vec_trans_vec(vec_r_kp1, vec_r_kp1, size, r_t_r_kp1);

	b_k = r_t_r_kp1/r_t_r_k;

}
*/


void get_p_kp1(float vec_r_k[], float &beta, float vec_p_k[], long &size){

	for(long n=0;n<size;n++){

		vec_p_k[n] *=  beta;
		vec_p_k[n] += vec_r_k[n]; 

	}

}

void conj_grad(float vec_x[], float vec_b[], sparse_matrix &A, float &stop_cri, parameters &param){


	float r_norm_current = 0;
	float r_norm_p1 = 0;
	float alpha = 0;
	float beta = 0;
	float p_A_p = 0;
	float r_norm_max;

	long k_max;
	long k_min;
	if(param.jagged_compression == false){
		k_max = 100;
		k_min = 10;
	}else{
		k_max = 300;
		k_min = 0;
	}
	


	get_r0(param.vec_b, param.vec_x, A, param.vec_r_k, param);

	vec_trans_vec( param.vec_r_k, param.vec_r_k, A.length, r_norm_current);

	//cout << "got r0" << endl;
	//cout << vec_r_k[0] << " " << vec_r_k[1] << endl;

	for(long n=0;n<A.length;n++){

		param.vec_p_k[n] = param.vec_r_k[n];
		param.vec_x_k[n] = param.vec_x[n];

	}
	
	//for(long n=0;n<100;n++){
	//	cout << A.e[n].row << " " << A.e[n].column << " " << A.e[n].val << endl;
	//}
	

	for(short k=0;k<k_max;k++){

		sparse_matrix_m_vec(A, param.vec_p_k, param.vec_A_p_k);

		vec_trans_vec( param.vec_p_k, param.vec_A_p_k, A.length, p_A_p);

		alpha = r_norm_current/p_A_p;

		//cout << p_A_p << " ";

		//get_alpha_k(param.vec_r_k, param.vec_p_k, param.vec_A_p_k, A.length, alpha);

		
		get_x_kp1(param.vec_x_k, alpha, param.vec_p_k, A.length);

		get_r_kp1(param.vec_r_k, alpha, param.vec_A_p_k, A.length);

		vec_trans_vec( param.vec_r_k, param.vec_r_k, A.length, r_norm_p1);

		beta = r_norm_p1/r_norm_current;

		//vec_trans_vec( param.vec_r_kp1, param.vec_r_kp1, A.length, r_norm);
		vec_abs_max(param.vec_r_k,A.length, r_norm_max);

		//cout << r_norm << endl;

		if( (r_norm_max < (stop_cri) ) ){

			cout << "break at " << k << endl;

			break;

		}
		//}

		//get_b_k(param.vec_r_k, param.vec_r_kp1, A.length, beta);

		get_p_kp1(param.vec_r_k, beta, param.vec_p_k, A.length);

		r_norm_current = r_norm_p1;



	}


	for(long n=0;n<A.length;n++){

			param.vec_x[n] = param.vec_x_k[n];

	}




	//for(long n=0;n<A.length;n++){

		//	cout << vec_x[n] << endl;

	//}


}













		





