#include "stdafx.h"

void cross_product(float a[], float b[], float vec_out[]);
float vec_length(float vec[]);

void get_normal(face face_class[], long &nn, parameters &param){
//void face::get_normal(float nodes []){

	//normals point outward (away from the tetrahedrah

	//cout << region << endl;

	float a[3],b[3],c[3],d[3],v1[3],v2[3],v3[3],n[3];
	float n_length, dot;

	long n1,n2,n3;
	long t1;

	n1 = face_class[nn].node1;
	n2 = face_class[nn].node2;
	n3 = face_class[nn].node3;



	a[0] = param.n_x[n1];
	a[1] = param.n_y[n1];
	a[2] = param.n_z[n1];

	b[0] = param.n_x[n2];
	b[1] = param.n_y[n2];
	b[2] = param.n_z[n2];

	c[0] = param.n_x[n3];
	c[1] = param.n_y[n3];
	c[2] = param.n_z[n3];

	//d[0] = nodes_(tet_node1,0);
	//d[1] = nodes_(tet_node1,1);
	//d[2] = nodes_(tet_node1,2);
	t1=face_class[nn].tet_node1;

	d[0] = param.n_x[t1];
	d[1] = param.n_y[t1];
	d[2] = param.n_z[t1];

	v1[0] = b[0]-a[0];
	v1[1] = b[1]-a[1];
	v1[2] = b[2]-a[2];

	v2[0] = c[0]-a[0];
	v2[1] = c[1]-a[1];
	v2[2] = c[2]-a[2];

	v3[0] = d[0]-a[0];
	v3[1] = d[1]-a[1];
	v3[2] = d[2]-a[2];

	cross_product(v1,v2,n);

	n_length = vec_length(n);

	face_class[nn].area = .5*n_length;

	n[0] = n[0]/n_length;
	n[1] = n[1]/n_length;
	n[2] = n[2]/n_length;

	dot = n[0]*v3[0]+n[1]*v3[1]+n[2]*v3[2];

	if(dot < 0){

		face_class[nn].normal1[0]=n[0];
		face_class[nn].normal1[1]=n[1];
		face_class[nn].normal1[2]=n[2];
		face_class[nn].normal2[0]=-n[0];
		face_class[nn].normal2[1]=-n[1];
		face_class[nn].normal2[2]=-n[2];

	}
	if(dot > 0){

		face_class[nn].normal1[0]=-n[0];
		face_class[nn].normal1[1]=-n[1];
		face_class[nn].normal1[2]=-n[2];
		face_class[nn].normal2[0]=n[0];
		face_class[nn].normal2[1]=n[1];
		face_class[nn].normal2[2]=n[2];

	}
	if(dot == 0){
		cout << "error tetrahedrah face normal" << endl;
		exit(1);
	}


}


long get_faces_number( node_info node_class[], parameters &param){

	//for now, we let the faces float up
	short r;
	long p[4];
	short boundary_pt_number;
	long face_num;
	face_num=0;

	for(long n=0;n<param.tets_number;n++){

		p[0] = param.t_1[n];
		p[1] = param.t_2[n];
		p[2] = param.t_3[n];
		p[3] = param.t_4[n];
		r = param.t_r[n];

		boundary_pt_number = 0;
		for(short m=0;m<4;m++){
			if(node_class[p[m]].boundary == true){
				//if(r!=0){
					boundary_pt_number=boundary_pt_number+1;
				//}
			}
		}
		if(boundary_pt_number == 3){
			face_num = face_num+1;
		}
		
	}

	return face_num;

}


void get_faces( node_info node_class[], face face_class[], parameters &param){

	//for now, we let the faces float up

	short r;
	short boundary_pt_number;
	long t[3];
	long other;
	long p[4];
	long face_num = 0;

	for(long n=0;n<param.tets_number;n++){

		p[0] = param.t_1[n];
		p[1] = param.t_2[n];
		p[2] = param.t_3[n];
		p[3] = param.t_4[n];
		r = param.t_r[n];

		boundary_pt_number = 0;
		t[0]=0;
		t[1]=0;
		t[2]=0;
		for(short m=0;m<4;m++){
			if(node_class[p[m]].boundary == true){
				//if(r!=0){
					t[boundary_pt_number] = p[m];
					boundary_pt_number=boundary_pt_number+1;
				//}
			}else{
				other = p[m];
			}
		}
		if(boundary_pt_number == 3){
			face_class[face_num].node1 = t[0];
			face_class[face_num].node2 = t[1];
			face_class[face_num].node3 = t[2];
			face_class[face_num].tet1 = n;
			face_class[face_num].tet_node1 = other;
			face_class[face_num].region = param.t_r[n];
			face_num = face_num+1;

			if( (node_class[t[0]].boundary_0 == true) && (node_class[t[1]].boundary_0 == true) && (node_class[t[2]].boundary_0 == true) ){
				face_class[face_num].bdry_0 = true;
			}else{
				face_class[face_num].bdry_0 = false;
			}

		}
		
	}

}


//put in calculate forces

