#include "stdafx.h"
#include "sparse_matrix.h"

void cross_product(float a[], float b[], float vec_out[]);
float vec_length(float vec[]);

void add(long size, float A[], float B[], float M[]);
void m_const(long size, float input[], float constant, float M[]);
float det3(float input[], parameters &param);
void inv3(float input[], float M[], parameters &param);
void transpose3(float input[], float M[]);
void eye3(float M[]);
float trace3(float input[]);
void m(float A[], float B[], float M[]);

float dot3(float v1[3], float v2[3]);



void get_alt_forces(node_info node_class[], parameters &param){

	long p1, p2, p3, p4;
	float x1, x2, x3, x4, y1, y2, y3, y4, z1, z2, z3, z4;

	float n1[3],n2[3],n3[3],n4[3];
		float n1_length,n2_length,n3_length,n4_length;
		float vec1[3],vec2[3],vec3[3],vec4[3],vec5[3],vec6[3];
		float alt_p1[3], alt_p2[3], alt_p3[3], alt_p4[3];
		float alt1[3], alt2[3], alt3[3], alt4[3];
		float alt_length1, alt_length2, alt_length3, alt_length4;
		float v[3];
		float F[9];
		float inv3_dX[9];
		float dx[9];
		short smallest_alt;
		short largest_alt;
		float smallest_alt_length;
		float largest_alt_length;
		float ratio;
		float largest_ratio;
		largest_ratio = 0;

		for(long n=0;n<param.nodes_number;n++){

			param.enf_x[n]=0;
			param.enf_y[n]=0;
			param.enf_z[n]=0;

		}



		for(long ii=0;ii<param.tets_number;ii++){   



			p1=param.t_1[ii];
			p2=param.t_2[ii];
			p3=param.t_3[ii];
			p4=param.t_4[ii];


			x1 = param.n_x[p1];
			x2 = param.n_x[p2];
			x3 = param.n_x[p3];
			x4 = param.n_x[p4];
			y1 = param.n_y[p1];
			y2 = param.n_y[p2];
			y3 = param.n_y[p3];
			y4 = param.n_y[p4];
			z1 = param.n_z[p1];
			z2 = param.n_z[p2];
			z3 = param.n_z[p3];
			z4 = param.n_z[p4];
	





			vec1[0]=x2-x1;
			vec1[1]=y2-y1;
			vec1[2]=z2-z1;

			vec2[0]=x3-x1;
			vec2[1]=y3-y1;
			vec2[2]=z3-z1;

			vec3[0]=x4-x1;
			vec3[1]=y4-y1;
			vec3[2]=z4-z1;

			vec4[0]=x3-x2;
			vec4[1]=y3-y2;
			vec4[2]=z3-z2;

			vec5[0]=x4-x2;
			vec5[1]=y4-y2;
			vec5[2]=z4-z2;

			vec6[0]=x4-x3;
			vec6[1]=y4-y3;
			vec6[2]=z4-z3;

			cross_product(vec2,vec1,n4);
			cross_product(vec1,vec3,n3);
			cross_product(vec3,vec2,n2);
			cross_product(vec4,vec5,n1);

			n1_length=vec_length(n1);
			n2_length=vec_length(n2);
			n3_length=vec_length(n3);
			n4_length=vec_length(n4);

			for(short ww=0;ww<3;ww++){

					n1[ww]=n1[ww]/n1_length;
					n2[ww]=n2[ww]/n2_length;
					n3[ww]=n3[ww]/n3_length;
					n4[ww]=n4[ww]/n4_length;

			}

			for(short bb=0;bb<3;bb++){
					v[bb]=-vec1[bb];
			}

				alt_p1[0]=n1[0]*n1[0]*v[0] + n1[0]*n1[1]*v[1] + n1[0]*n1[2]*v[2];
				alt_p1[1]=n1[0]*n1[1]*v[0] + n1[1]*n1[1]*v[1] + n1[1]*n1[2]*v[2];
				alt_p1[2]=n1[0]*n1[2]*v[0] + n1[1]*n1[2]*v[1] + n1[2]*n1[2]*v[2];

				alt_length1 = vec_length(alt_p1);
				
				for(short bb=0;bb<3;bb++){
					v[bb]=vec1[bb];
				}

				alt_p2[0]=n2[0]*n2[0]*v[0] + n2[0]*n2[1]*v[1] + n2[0]*n2[2]*v[2];
				alt_p2[1]=n2[0]*n2[1]*v[0] + n2[1]*n2[1]*v[1] + n2[1]*n2[2]*v[2];
				alt_p2[2]=n2[0]*n2[2]*v[0] + n2[1]*n2[2]*v[1] + n2[2]*n2[2]*v[2];

				alt_length2 = vec_length(alt_p2);

				for(short bb=0;bb<3;bb++){
					v[bb]=vec4[bb];
				}

				alt_p3[0]=n3[0]*n3[0]*v[0] + n3[0]*n3[1]*v[1] + n3[0]*n3[2]*v[2];
				alt_p3[1]=n3[0]*n3[1]*v[0] + n3[1]*n3[1]*v[1] + n3[1]*n3[2]*v[2];
				alt_p3[2]=n3[0]*n3[2]*v[0] + n3[1]*n3[2]*v[1] + n3[2]*n3[2]*v[2];

				alt_length3 = vec_length(alt_p3);

				for(short bb=0;bb<3;bb++){
					v[bb]=vec3[bb];
				}

				alt_p4[0]=n4[0]*n4[0]*v[0] + n4[0]*n4[1]*v[1] + n4[0]*n4[2]*v[2];
				alt_p4[1]=n4[0]*n4[1]*v[0] + n4[1]*n4[1]*v[1] + n4[1]*n4[2]*v[2];
				alt_p4[2]=n4[0]*n4[2]*v[0] + n4[1]*n4[2]*v[1] + n4[2]*n4[2]*v[2];

				alt_length4 = vec_length(alt_p4);





				if( (alt_length1 <= alt_length2) && (alt_length1 <= alt_length3) && (alt_length1 <= alt_length4) ){

					smallest_alt = 1;
					smallest_alt_length = alt_length1;



				}

				if( (alt_length2 <= alt_length1) && (alt_length2 <= alt_length3) && (alt_length2 <= alt_length4) ){

					smallest_alt = 2;
					smallest_alt_length = alt_length2;



				}

				if( (alt_length3 <= alt_length1) && (alt_length3 <= alt_length2) && (alt_length3 <= alt_length4) ){

					smallest_alt = 3;
					smallest_alt_length = alt_length3;



				}

				if( (alt_length4 <= alt_length1) && (alt_length4 <= alt_length2) && (alt_length4 <= alt_length3) ){

					smallest_alt = 4;
					smallest_alt_length = alt_length4;



				}

				//

				if( (alt_length1 >= alt_length2) && (alt_length1 >= alt_length3) && (alt_length1 >= alt_length4) ){

					largest_alt = 1;
					largest_alt_length = alt_length1;



				}

				if( (alt_length2 >= alt_length1) && (alt_length2 >= alt_length3) && (alt_length2 >= alt_length4) ){

					largest_alt = 2;
					largest_alt_length = alt_length2;



				}

				if( (alt_length3 >= alt_length1) && (alt_length3 >= alt_length2) && (alt_length3 >= alt_length4) ){

					largest_alt = 3;
					largest_alt_length = alt_length3;



				}

				if( (alt_length4 >= alt_length1) && (alt_length4 >= alt_length2) && (alt_length4 >= alt_length3) ){

					largest_alt = 4;
					largest_alt_length = alt_length4;



				}

				//

				ratio = largest_alt_length/smallest_alt_length - 2.0;

				

				if(ratio > 0){

					if(ratio>largest_ratio){
						largest_ratio = ratio;
					}


					if(smallest_alt == 1){

						param.enf_x[p1] = param.enf_x[p1] +ratio*alt_p1[0];
						param.enf_y[p1] = param.enf_y[p1] +ratio*alt_p1[1];
						param.enf_z[p1] = param.enf_z[p1] +ratio*alt_p1[2];

						param.enf_x[p2] = param.enf_x[p2] -ratio*alt_p1[0];
						param.enf_y[p2] = param.enf_y[p2] -ratio*alt_p1[1];
						param.enf_z[p2] = param.enf_z[p2] -ratio*alt_p1[2];

						param.enf_x[p3] = param.enf_x[p3] -ratio*alt_p1[0];
						param.enf_y[p3] = param.enf_y[p3] -ratio*alt_p1[1];
						param.enf_z[p3] = param.enf_z[p3] -ratio*alt_p1[2];

						param.enf_x[p4] = param.enf_x[p4] -ratio*alt_p1[0];
						param.enf_y[p4] = param.enf_y[p4] -ratio*alt_p1[1];
						param.enf_z[p4] = param.enf_z[p4] -ratio*alt_p1[2];

					}

					if(smallest_alt == 2){

						param.enf_x[p1] = param.enf_x[p1] -ratio*alt_p2[0];
						param.enf_y[p1] = param.enf_y[p1] -ratio*alt_p2[1];
						param.enf_z[p1] = param.enf_z[p1] -ratio*alt_p2[2];

						param.enf_x[p2] = param.enf_x[p2] +ratio*alt_p2[0];
						param.enf_y[p2] = param.enf_y[p2] +ratio*alt_p2[1];
						param.enf_z[p2] = param.enf_z[p2] +ratio*alt_p2[2];

						param.enf_x[p3] = param.enf_x[p3] -ratio*alt_p2[0];
						param.enf_y[p3] = param.enf_y[p3] -ratio*alt_p2[1];
						param.enf_z[p3] = param.enf_z[p3] -ratio*alt_p2[2];

						param.enf_x[p4] = param.enf_x[p4] -ratio*alt_p2[0];
						param.enf_y[p4] = param.enf_y[p4] -ratio*alt_p2[1];
						param.enf_z[p4] = param.enf_z[p4] -ratio*alt_p2[2];

					}

					if(smallest_alt == 3){

						param.enf_x[p1] = param.enf_x[p1] -ratio*alt_p3[0];
						param.enf_y[p1] = param.enf_y[p1] -ratio*alt_p3[1];
						param.enf_z[p1] = param.enf_z[p1] -ratio*alt_p3[2];

						param.enf_x[p2] = param.enf_x[p2] -ratio*alt_p3[0];
						param.enf_y[p2] = param.enf_y[p2] -ratio*alt_p3[1];
						param.enf_z[p2] = param.enf_z[p2] -ratio*alt_p3[2];

						param.enf_x[p3] = param.enf_x[p3] +ratio*alt_p3[0];
						param.enf_y[p3] = param.enf_y[p3] +ratio*alt_p3[1];
						param.enf_z[p3] = param.enf_z[p3] +ratio*alt_p3[2];

						param.enf_x[p4] = param.enf_x[p4] -ratio*alt_p3[0];
						param.enf_y[p4] = param.enf_y[p4] -ratio*alt_p3[1];
						param.enf_z[p4] = param.enf_z[p4] -ratio*alt_p3[2];

					}

					if(smallest_alt == 4){

						param.enf_x[p1] = param.enf_x[p1] -ratio*alt_p4[0];
						param.enf_y[p1] = param.enf_y[p1] -ratio*alt_p4[1];
						param.enf_z[p1] = param.enf_z[p1] -ratio*alt_p4[2];

						param.enf_x[p2] = param.enf_x[p2] -ratio*alt_p4[0];
						param.enf_y[p2] = param.enf_y[p2] -ratio*alt_p4[1];
						param.enf_z[p2] = param.enf_z[p2] -ratio*alt_p4[2];

						param.enf_x[p3] = param.enf_x[p3] -ratio*alt_p4[0];
						param.enf_y[p3] = param.enf_y[p3] -ratio*alt_p4[1];
						param.enf_z[p3] = param.enf_z[p3] -ratio*alt_p4[2];

						param.enf_x[p4] = param.enf_x[p4] +ratio*alt_p4[0];
						param.enf_y[p4] = param.enf_y[p4] +ratio*alt_p4[1];
						param.enf_z[p4] = param.enf_z[p4] +ratio*alt_p4[2];

					}
					

					//

					if(largest_alt == 1){

						param.enf_x[p1] = param.enf_x[p1] -ratio*alt_p1[0];
						param.enf_y[p1] = param.enf_y[p1] -ratio*alt_p1[1];
						param.enf_z[p1] = param.enf_z[p1] -ratio*alt_p1[2];

						param.enf_x[p2] = param.enf_x[p2] +ratio*alt_p1[0];
						param.enf_y[p2] = param.enf_y[p2] +ratio*alt_p1[1];
						param.enf_z[p2] = param.enf_z[p2] +ratio*alt_p1[2];

						param.enf_x[p3] = param.enf_x[p3] +ratio*alt_p1[0];
						param.enf_y[p3] = param.enf_y[p3] +ratio*alt_p1[1];
						param.enf_z[p3] = param.enf_z[p3] +ratio*alt_p1[2];

						param.enf_x[p4] = param.enf_x[p4] +ratio*alt_p1[0];
						param.enf_y[p4] = param.enf_y[p4] +ratio*alt_p1[1];
						param.enf_z[p4] = param.enf_z[p4] +ratio*alt_p1[2];

					}

					if(largest_alt == 2){

						param.enf_x[p1] = param.enf_x[p1] +ratio*alt_p2[0];
						param.enf_y[p1] = param.enf_y[p1] +ratio*alt_p2[1];
						param.enf_z[p1] = param.enf_z[p1] +ratio*alt_p2[2];

						param.enf_x[p2] = param.enf_x[p2] -ratio*alt_p2[0];
						param.enf_y[p2] = param.enf_y[p2] -ratio*alt_p2[1];
						param.enf_z[p2] = param.enf_z[p2] -ratio*alt_p2[2];

						param.enf_x[p3] = param.enf_x[p3] +ratio*alt_p2[0];
						param.enf_y[p3] = param.enf_y[p3] +ratio*alt_p2[1];
						param.enf_z[p3] = param.enf_z[p3] +ratio*alt_p2[2];

						param.enf_x[p4] = param.enf_x[p4] +ratio*alt_p2[0];
						param.enf_y[p4] = param.enf_y[p4] +ratio*alt_p2[1];
						param.enf_z[p4] = param.enf_z[p4] +ratio*alt_p2[2];

					}

					if(largest_alt == 3){

						param.enf_x[p1] = param.enf_x[p1] +ratio*alt_p3[0];
						param.enf_y[p1] = param.enf_y[p1] +ratio*alt_p3[1];
						param.enf_z[p1] = param.enf_z[p1] +ratio*alt_p3[2];

						param.enf_x[p2] = param.enf_x[p2] +ratio*alt_p3[0];
						param.enf_y[p2] = param.enf_y[p2] +ratio*alt_p3[1];
						param.enf_z[p2] = param.enf_z[p2] +ratio*alt_p3[2];

						param.enf_x[p3] = param.enf_x[p3] -ratio*alt_p3[0];
						param.enf_y[p3] = param.enf_y[p3] -ratio*alt_p3[1];
						param.enf_z[p3] = param.enf_z[p3] -ratio*alt_p3[2];

						param.enf_x[p4] = param.enf_x[p4] +ratio*alt_p3[0];
						param.enf_y[p4] = param.enf_y[p4] +ratio*alt_p3[1];
						param.enf_z[p4] = param.enf_z[p4] +ratio*alt_p3[2];

					}

					if(largest_alt == 4){

						param.enf_x[p1] = param.enf_x[p1] +ratio*alt_p4[0];
						param.enf_y[p1] = param.enf_y[p1] +ratio*alt_p4[1];
						param.enf_z[p1] = param.enf_z[p1] +ratio*alt_p4[2];

						param.enf_x[p2] = param.enf_x[p2] +ratio*alt_p4[0];
						param.enf_y[p2] = param.enf_y[p2] +ratio*alt_p4[1];
						param.enf_z[p2] = param.enf_z[p2] +ratio*alt_p4[2];

						param.enf_x[p3] = param.enf_x[p3] +ratio*alt_p4[0];
						param.enf_y[p3] = param.enf_y[p3] +ratio*alt_p4[1];
						param.enf_z[p3] = param.enf_z[p3] +ratio*alt_p4[2];

						param.enf_x[p4] = param.enf_x[p4] -ratio*alt_p4[0];
						param.enf_y[p4] = param.enf_y[p4] -ratio*alt_p4[1];
						param.enf_z[p4] = param.enf_z[p4] -ratio*alt_p4[2];

					}





				}

				}	
				
				cout << "largest ratio " << largest_ratio << endl;
		

	}



void construct_eq_dX(float tet_volumes[], parameters &param){

	float eq_length;
	float dX[9];
	float inv3_dX[9];
	float v_calc_matrix[9];
	float asv;

	for(long ii=0;ii<param.tets_number;ii++){  

		float X1,X2,X3,X4,Y1,Y2,Y3,Y4,Z1,Z2,Z3,Z4;
		long p1,p2,p3,p4;

			p1=param.t_1[ii];
			p2=param.t_2[ii];
			p3=param.t_3[ii];
			p4=param.t_4[ii];

			//r=param.t_r[ii];


			X1 = param.n_x[p1];
			X2 = param.n_x[p2];
			X3 = param.n_x[p3];
			X4 = param.n_x[p4];
			Y1 = param.n_y[p1];
			Y2 = param.n_y[p2];
			Y3 = param.n_y[p3];
			Y4 = param.n_y[p4];
			Z1 = param.n_z[p1];
			Z2 = param.n_z[p2];
			Z3 = param.n_z[p3];
			Z4 = param.n_z[p4];


		v_calc_matrix[0]=X1-X2;
		v_calc_matrix_(0,1)=X2-X3;
		v_calc_matrix_(0,2)=X3-X4;
		v_calc_matrix_(1,0)=Y1-Y2;
		v_calc_matrix_(1,1)=Y2-Y3;
		v_calc_matrix_(1,2)=Y3-Y4;
		v_calc_matrix_(2,0)=Z1-Z2;
		v_calc_matrix_(2,1)=Z2-Z3;
		v_calc_matrix_(2,2)=Z3-Z4;
		

		asv = (1.0/6.0)*det3(v_calc_matrix, param);
		if(asv > 0){
			tet_volumes[ii] =  asv;
		}else{
			tet_volumes[ii] =  -1.0*asv;

		}

		//////////

		eq_length = pow( (8.48528*tet_volumes[ii]), .33333333);


		dX_(0,0)=1;
		dX_(1,0)=0;
		dX_(2,0)=0;

		dX_(0,1)=.5;
		dX_(1,1)=.866025;
		dX_(2,1)=0;

		dX_(0,2)=.5;
		dX_(1,2)=.433013;
		dX_(2,2)=.75;

		m_const(9,dX,eq_length,dX);



		param.dX_array_0[ii]=dX[0];
		param.dX_array_3[ii]=dX_(0,1);
		param.dX_array_6[ii]=dX_(0,2);
		param.dX_array_1[ii]=dX_(1,0);
		param.dX_array_4[ii]=dX_(1,1);
		param.dX_array_7[ii]=dX_(1,2);
		param.dX_array_2[ii]=dX_(2,0);
		param.dX_array_5[ii]=dX_(2,1);
		param.dX_array_8[ii]=dX_(2,2);
		
		inv3(dX, inv3_dX, param);

		param.inv3_dX_array_0[ii]=inv3_dX[0];
		param.inv3_dX_array_3[ii]=inv3_dX_(0,1);
		param.inv3_dX_array_6[ii]=inv3_dX_(0,2);
		param.inv3_dX_array_1[ii]=inv3_dX_(1,0);
		param.inv3_dX_array_4[ii]=inv3_dX_(1,1);
		param.inv3_dX_array_7[ii]=inv3_dX_(1,2);
		param.inv3_dX_array_2[ii]=inv3_dX_(2,0);
		param.inv3_dX_array_5[ii]=inv3_dX_(2,1);
		param.inv3_dX_array_8[ii]=inv3_dX_(2,2);

	}

}


void calculate_elastic_forces_imq(float tet_volumes[], node_info node_class[], float current_tet_volumes[], parameters &param){



	for(long n=0;n<param.nodes_number;n++){

		param.enf_x[n]=0;
		param.enf_y[n]=0;
		param.enf_z[n]=0;

	}


	//X is the underformed configuration, x is the deformed config
	//going through all the triangles and finding the cauchy 
	//stress and using that to find the force



		long p1, p2, p3, p4;
		float x1, x2, x3, x4, y1, y2, y3, y4, z1, z2, z3, z4;
		//float prev_x1, prev_x2, prev_x3, prev_x4, prev_y1, prev_y2, prev_y3, prev_y4, prev_z1, prev_z2, prev_z3, prev_z4;


		//E is young's modulus and p us the poisson ratio

		float p=param.p;
		float E= param.E;
		float d=1.0;

		float lambda = (E*p)/((1.0+p)*(1.0-2.0*p));
		float mu = E/(2.0*(1.0+p));
		float alpha;
		alpha = lambda * d;
		float beta;
		beta = mu* d;

		float I[9];
		

		float dx[9];
		float dX[9];
		float inv3_dX[9];
		float inv3_dx[9];
		float F[9];
		float b[9];
		float trans3_F[9];
		float J;
		float sigma[9];
		float val1;
		float val2;
		float val3;
		float J1, J2, J3;
		float M1[9];
		float M2[9];
		float M3[9];
		float M4[9];
		float M5[9];
		float M6[9];
		float P[9];
		float ftwo_fthree_ffour[9];
		float fone[3];

		float G[9];
		float S[9];

		float A1,A2,A3,A4;
		float n1[3],n2[3],n3[3],n4[3];
		float n1_length,n2_length,n3_length,n4_length;
		float vec1[3],vec2[3],vec3[3],vec4[3],vec5[3],vec6[3];
		float alt_p1[3], alt_p2[3], alt_p3[3], alt_p4[3];
		float alt1[3], alt2[3], alt3[3], alt4[3];
		float alt_length1, alt_length2, alt_length3, alt_length4;
		float rest_alt1, rest_alt2, rest_alt3, rest_alt4;
		float f1,f2,f3,f4;
		float v[3];
		float k;
		k = 3.0*alpha*2.0;
		float boundary_number;
		float e_fnc;
		float ls1, ls2, ls3, ls4, ls_avg;
		short r;

		short comp12,comp13,comp14,comp23,comp24,comp34;
		short smallest_alt;
		float min_alt, max_alt, ratio;

		float d_ang, max_d_ang, min_d_ang;
		float this_max_d_ang, this_min_d_ang;
		float largest_edge;
		float smallest_edge;
		float edge_ratio;
		float largest_edge_ratio;
		float vec1_l,vec2_l,vec3_l,vec4_l,vec5_l,vec6_l;
		largest_edge_ratio = 1;

		float alt_rest_change;

		float detC;
		float detC_m1;
		float detF;
		float detF_m1;
		float trace_C;

		float asv;

		param.inverted_count=0;
		float C[9];
		float C_inv[9];

		min_d_ang = 2*param.pi;
		max_d_ang = 0;

		//cout << "elastic started" << endl;


		

		for(long ii=0;ii<param.tets_number;ii++){   

			//cout << " ii " << endl;

			p1=param.t_1[ii];
			p2=param.t_2[ii];
			p3=param.t_3[ii];
			p4=param.t_4[ii];

			//r=param.t_r[ii];


			x1 = param.n_x[p1];
			x2 = param.n_x[p2];
			x3 = param.n_x[p3];
			x4 = param.n_x[p4];
			y1 = param.n_y[p1];
			y2 = param.n_y[p2];
			y3 = param.n_y[p3];
			y4 = param.n_y[p4];
			z1 = param.n_z[p1];
			z2 = param.n_z[p2];
			z3 = param.n_z[p3];
			z4 = param.n_z[p4];

			

			dx[0] = x2-x1;
			dx[3] = x3-x1;
			dx[6] = x4-x1;
			dx[1] = y2-y1;
			dx[4] = y3-y1;
			dx[7] = y4-y1;
			dx[2] = z2-z1;
			dx[5] = z3-z1;
			dx[8] = z4-z1;



			inv3_dX[0]=param.inv3_dX_array_0[ii];
			inv3_dX[3]=param.inv3_dX_array_3[ii];
			inv3_dX[6]=param.inv3_dX_array_6[ii];
			inv3_dX[1]=param.inv3_dX_array_1[ii];
			inv3_dX[4]=param.inv3_dX_array_4[ii];
			inv3_dX[7]=param.inv3_dX_array_7[ii];
			inv3_dX[2]=param.inv3_dX_array_2[ii];
			inv3_dX[5]=param.inv3_dX_array_5[ii];
			inv3_dX[8]=param.inv3_dX_array_8[ii];

			
			dX[0]=param.dX_array_0[ii];
			dX[3]=param.dX_array_3[ii];
			dX[6]=param.dX_array_6[ii];
			dX[1]=param.dX_array_1[ii];
			dX[4]=param.dX_array_4[ii];
			dX[7]=param.dX_array_7[ii];
			dX[2]=param.dX_array_2[ii];
			dX[5]=param.dX_array_5[ii];
			dX[8]=param.dX_array_8[ii];


			m(dx, inv3_dX, F);

			///

			inv3(dx,inv3_dx, param);


			param.inv3_dx_array_0[ii]=inv3_dx[0];
			param.inv3_dx_array_3[ii]=inv3_dx[3];
			param.inv3_dx_array_6[ii]=inv3_dx[6];
			param.inv3_dx_array_1[ii]=inv3_dx[1];
			param.inv3_dx_array_4[ii]=inv3_dx[4];
			param.inv3_dx_array_7[ii]=inv3_dx[7];
			param.inv3_dx_array_2[ii]=inv3_dx[2];
			param.inv3_dx_array_5[ii]=inv3_dx[5];
			param.inv3_dx_array_8[ii]=inv3_dx[8];

			////

			asv = (1.0/6.0)*det3(dx, param);
			if(asv > 0){
				current_tet_volumes[ii] =  asv;
			}else{
				current_tet_volumes[ii] =  -1.0*asv;
			}
			

			/////////////////////////////////////////////////////////////////////////////////////////////////////////////

			vec1[0]=dx_(0,0);
			vec1[1]=dx_(1,0);
			vec1[2]=dx_(2,0);

			vec2[0]=dx_(0,1);
			vec2[1]=dx_(1,1);
			vec2[2]=dx_(2,1);

			vec3[0]=dx_(0,2);
			vec3[1]=dx_(1,2);
			vec3[2]=dx_(2,2);

			vec4[0]=x3-x2;
			vec4[1]=y3-y2;
			vec4[2]=z3-z2;

			vec5[0]=x4-x2;
			vec5[1]=y4-y2;
			vec5[2]=z4-z2;

			vec6[0]=x4-x3;
			vec6[1]=y4-y3;
			vec6[2]=z4-z3;

			cross_product(vec2,vec1,n4);
			cross_product(vec1,vec3,n3);
			cross_product(vec3,vec2,n2);
			cross_product(vec4,vec5,n1);

			n1_length=vec_length(n1);
			n2_length=vec_length(n2);
			n3_length=vec_length(n3);
			n4_length=vec_length(n4);

				

				


				

				for(short ww=0;ww<3;ww++){

					n1[ww]=n1[ww]/n1_length;
					n2[ww]=n2[ww]/n2_length;
					n3[ww]=n3[ww]/n3_length;
					n4[ww]=n4[ww]/n4_length;

				}


				this_min_d_ang = 2*param.pi;
				this_max_d_ang = 0;

				

					d_ang = acos(-dot3(n1,n2));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}

					d_ang = acos(-dot3(n1,n3));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}

					d_ang = acos(-dot3(n1,n4));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}

					d_ang = acos(-dot3(n2,n3));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}

					d_ang = acos(-dot3(n2,n4));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}

					d_ang = acos(-dot3(n3,n4));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}
					if(d_ang < this_min_d_ang){
						this_min_d_ang = d_ang;
					}
					if(d_ang > this_max_d_ang){
						this_max_d_ang = d_ang;
					}




				/////////////////////////////////////////////////////////////////////////////////////////////////////////


		
				detF = det3(F, param);


				m(dX,inv3_dx, M2);

				transpose3(M2,M3);

				m(M2,M3,C_inv);

				

				detF_m1=detF-1;

				transpose3(F, trans3_F);
				m(trans3_F, F, C);

				//detC = det3(C);
				//detC_m1 = detC - 1.0;

				if(detF < 1.0){

				val1 = 16.0*lambda*detF_m1*detF_m1*detF_m1*detF + 3*mu*(2*detF - 3)*detF;

				}else{

					val1 = 3*mu*(2*detF - 3)*detF;

				}

				m_const(9, M3, val1, M4);


				m_const(9, F, mu, M1);


				add(9, M1, M4, M5);
				
				eye3(I);

				trace_C = trace3(C);

				m_const(9,I,mu*trace_C,M1);

				m_const(9,C,mu*(-1.0),M2);

				add(9,M1,M2,M3);

				m(F,M3,M4);

				add(9,M4,M5,P);

			

			///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


			//ftwo_fthree_ffour = -1.0*tet_volumes(i)* P * transpose3(inv3_dX) ;

			transpose3(inv3_dX, M1);
			m_const(9, P, -1.0*tet_volumes[ii], M2);
			m(M2,M1,ftwo_fthree_ffour);

			//cout << "fs" << endl;
			//out3(ftwo_fthree_ffour);


			fone[0] = -1.0*ftwo_fthree_ffour[0] -1.0*ftwo_fthree_ffour[3] -1.0*ftwo_fthree_ffour[6];
			fone[1] = -1.0*ftwo_fthree_ffour[1] -1.0*ftwo_fthree_ffour[4] -1.0*ftwo_fthree_ffour[7];
			fone[2] = -1.0*ftwo_fthree_ffour[2] -1.0*ftwo_fthree_ffour[5] -1.0*ftwo_fthree_ffour[8];


			param.enf_x[p1] = param.enf_x[p1] + fone[0];
			param.enf_y[p1] = param.enf_y[p1] + fone[1];
			param.enf_z[p1] = param.enf_z[p1] + fone[2];

			param.enf_x[p2] = param.enf_x[p2] + ftwo_fthree_ffour[0];
			param.enf_y[p2] = param.enf_y[p2] + ftwo_fthree_ffour[1];
			param.enf_z[p2] = param.enf_z[p2] + ftwo_fthree_ffour[2];

			param.enf_x[p3] = param.enf_x[p3] + ftwo_fthree_ffour[3];
			param.enf_y[p3] = param.enf_y[p3] + ftwo_fthree_ffour[4];
			param.enf_z[p3] = param.enf_z[p3] + ftwo_fthree_ffour[5];

			param.enf_x[p4] = param.enf_x[p4] + ftwo_fthree_ffour[6];
			param.enf_y[p4] = param.enf_y[p4] + ftwo_fthree_ffour[7];
			param.enf_z[p4] = param.enf_z[p4] + ftwo_fthree_ffour[8];



			



		}

		

		cout << "min/max dihedral angle " << min_d_ang*180/param.pi << " " << max_d_ang*180/param.pi << endl;
		if( (min_d_ang*180/param.pi) < 1.0){
			cout << "min angle too small" << endl;
			exit(1);
		}



}




void improve_mesh_quality(float tet_volumes[], float current_tet_volumes[], node_info node_class[], parameters &param){

	construct_eq_dX(tet_volumes, param);

	for(long t=0;t<param.imq_time_step_number;t++){

		calculate_elastic_forces_imq(tet_volumes, node_class, current_tet_volumes, param);
	

		for(long n=0;n<(param.nodes_number);n++){
			
			if(node_class[n].boundary == false){

				param.n_x[n]=param.n_x[n]+param.imq_delta_t*param.enf_x[n];
				param.n_y[n]=param.n_y[n]+param.imq_delta_t*param.enf_y[n];
				param.n_z[n]=param.n_z[n]+param.imq_delta_t*param.enf_z[n];

			}

		}

	}

}



void get_stats(float tet_volumes[], node_info node_class[], float current_tet_volumes[], parameters &param){




	//X is the underformed configuration, x is the deformed config
	//going through all the triangles and finding the cauchy 
	//stress and using that to find the force



		long p1, p2, p3, p4;
		float x1, x2, x3, x4, y1, y2, y3, y4, z1, z2, z3, z4;
		//float prev_x1, prev_x2, prev_x3, prev_x4, prev_y1, prev_y2, prev_y3, prev_y4, prev_z1, prev_z2, prev_z3, prev_z4;


		//E is young's modulus and p us the poisson ratio

		float p=param.p;
		float E= param.E;
		float d=1.0;

		float lambda = (E*p)/((1.0+p)*(1.0-2.0*p));
		float mu = E/(2.0*(1.0+p));
		float alpha;
		alpha = lambda * d;
		float beta;
		beta = mu* d;

		float I[9];
		

		float dx[9];
		float dX[9];
		float inv3_dX[9];
		float inv3_dx[9];
		float F[9];
		float b[9];
		float trans3_F[9];
		float J;
		float sigma[9];
		float val1;
		float val2;
		float val3;
		float J1, J2, J3;
		float M1[9];
		float M2[9];
		float M3[9];
		float M4[9];
		float M5[9];
		float M6[9];
		float P[9];
		float ftwo_fthree_ffour[9];
		float fone[3];

		float G[9];
		float S[9];

		float A1,A2,A3,A4;
		float n1[3],n2[3],n3[3],n4[3];
		float n1_length,n2_length,n3_length,n4_length;
		float vec1[3],vec2[3],vec3[3],vec4[3],vec5[3],vec6[3];
		float alt_p1[3], alt_p2[3], alt_p3[3], alt_p4[3];
		float alt1[3], alt2[3], alt3[3], alt4[3];
		float alt_length1, alt_length2, alt_length3, alt_length4;
		float rest_alt1, rest_alt2, rest_alt3, rest_alt4;
		float f1,f2,f3,f4;
		float v[3];
		float k;
		k = 3.0*alpha*2.0;
		float boundary_number;
		float e_fnc;
		float ls1, ls2, ls3, ls4, ls_avg;
		short r;

		short comp12,comp13,comp14,comp23,comp24,comp34;
		short smallest_alt;
		float min_alt, max_alt, ratio;

		float d_ang, max_d_ang, min_d_ang;
		float this_max_d_ang, this_min_d_ang;
		float largest_edge;
		float smallest_edge;
		float edge_ratio;
		float largest_edge_ratio;
		float vec1_l,vec2_l,vec3_l,vec4_l,vec5_l,vec6_l;
		largest_edge_ratio = 1;

		float alt_rest_change;

		float detC;
		float detC_m1;
		float detF;
		float detF_m1;
		float trace_C;

		float asv;

		param.inverted_count=0;
		float C[9];
		float C_inv[9];

		min_d_ang = 2*param.pi;
		max_d_ang = 0;

		

		for(long ii=0;ii<param.tets_number;ii++){

			r = param.t_r[ii];
			if(r!=0){


			//cout << " ii " << endl;

			p1=param.t_1[ii];
			p2=param.t_2[ii];
			p3=param.t_3[ii];
			p4=param.t_4[ii];

			//r=param.t_r[ii];


			x1 = param.n_x[p1];
			x2 = param.n_x[p2];
			x3 = param.n_x[p3];
			x4 = param.n_x[p4];
			y1 = param.n_y[p1];
			y2 = param.n_y[p2];
			y3 = param.n_y[p3];
			y4 = param.n_y[p4];
			z1 = param.n_z[p1];
			z2 = param.n_z[p2];
			z3 = param.n_z[p3];
			z4 = param.n_z[p4];

			

			dx[0] = x2-x1;
			dx[3] = x3-x1;
			dx[6] = x4-x1;
			dx[1] = y2-y1;
			dx[4] = y3-y1;
			dx[7] = y4-y1;
			dx[2] = z2-z1;
			dx[5] = z3-z1;
			dx[8] = z4-z1;

			dX[0]=param.dX_array_0[ii];
			dX[3]=param.dX_array_3[ii];
			dX[6]=param.dX_array_6[ii];
			dX[1]=param.dX_array_1[ii];
			dX[4]=param.dX_array_4[ii];
			dX[7]=param.dX_array_7[ii];
			dX[2]=param.dX_array_2[ii];
			dX[5]=param.dX_array_5[ii];
			dX[8]=param.dX_array_8[ii];

			if(param.tets_number < param.tet_mem_lim ){

			inv3_dX[0]=param.inv3_dX_array_0[ii];
			inv3_dX[3]=param.inv3_dX_array_3[ii];
			inv3_dX[6]=param.inv3_dX_array_6[ii];
			inv3_dX[1]=param.inv3_dX_array_1[ii];
			inv3_dX[4]=param.inv3_dX_array_4[ii];
			inv3_dX[7]=param.inv3_dX_array_7[ii];
			inv3_dX[2]=param.inv3_dX_array_2[ii];
			inv3_dX[5]=param.inv3_dX_array_5[ii];
			inv3_dX[8]=param.inv3_dX_array_8[ii];

			}else{

				inv3(dX,inv3_dX, param);

			}

			
			


			m(dx, inv3_dX, F);

			///

			inv3(dx,inv3_dx, param);


			//param.inv3_dx_array_0[ii]=inv3_dx[0];
			//param.inv3_dx_array_3[ii]=inv3_dx[3];
			//param.inv3_dx_array_6[ii]=inv3_dx[6];
			//param.inv3_dx_array_1[ii]=inv3_dx[1];
			//param.inv3_dx_array_4[ii]=inv3_dx[4];
			//param.inv3_dx_array_7[ii]=inv3_dx[7];
			//param.inv3_dx_array_2[ii]=inv3_dx[2];
			//param.inv3_dx_array_5[ii]=inv3_dx[5];
			//param.inv3_dx_array_8[ii]=inv3_dx[8];

			
			

				

				//
				
			vec1[0]=dx_(0,0);
			vec1[1]=dx_(1,0);
			vec1[2]=dx_(2,0);

			vec2[0]=dx_(0,1);
			vec2[1]=dx_(1,1);
			vec2[2]=dx_(2,1);

			vec3[0]=dx_(0,2);
			vec3[1]=dx_(1,2);
			vec3[2]=dx_(2,2);

			vec4[0]=x3-x2;
			vec4[1]=y3-y2;
			vec4[2]=z3-z2;

			vec5[0]=x4-x2;
			vec5[1]=y4-y2;
			vec5[2]=z4-z2;

			vec6[0]=x4-x3;
			vec6[1]=y4-y3;
			vec6[2]=z4-z3;

			cross_product(vec2,vec1,n4);
			cross_product(vec1,vec3,n3);
			cross_product(vec3,vec2,n2);
			cross_product(vec4,vec5,n1);

			n1_length=vec_length(n1);
			n2_length=vec_length(n2);
			n3_length=vec_length(n3);
			n4_length=vec_length(n4);

				


				for(short ww=0;ww<3;ww++){

					n1[ww]=n1[ww]/n1_length;
					n2[ww]=n2[ww]/n2_length;
					n3[ww]=n3[ww]/n3_length;
					n4[ww]=n4[ww]/n4_length;

				}


				

					d_ang = acos(-dot3(n1,n2));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}


					d_ang = acos(-dot3(n1,n3));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}


					d_ang = acos(-dot3(n1,n4));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}


					d_ang = acos(-dot3(n2,n3));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}


					d_ang = acos(-dot3(n2,n4));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}


					d_ang = acos(-dot3(n3,n4));
					if(d_ang < min_d_ang){
						min_d_ang = d_ang;
					}
					if(d_ang > max_d_ang){
						max_d_ang = d_ang;
					}



				
				


					vec1_l = vec_length(vec1);
					vec2_l = vec_length(vec2);
					vec3_l = vec_length(vec3);
					vec4_l = vec_length(vec4);
					vec5_l = vec_length(vec5);
					vec6_l = vec_length(vec6);

					smallest_edge = vec1_l;
					if(vec2_l<smallest_edge){
						smallest_edge = vec2_l;
					}
					if(vec3_l<smallest_edge){
						smallest_edge = vec3_l;
					}
					if(vec4_l<smallest_edge){
						smallest_edge = vec4_l;
					}
					if(vec5_l<smallest_edge){
						smallest_edge = vec5_l;
					}
					if(vec6_l<smallest_edge){
						smallest_edge = vec6_l;
					}

					largest_edge = vec1_l;
					if(vec2_l>largest_edge){
						largest_edge = vec2_l;
					}
					if(vec3_l>largest_edge){
						largest_edge = vec3_l;
					}
					if(vec4_l>largest_edge){
						largest_edge = vec4_l;
					}
					if(vec5_l>largest_edge){
						largest_edge = vec5_l;
					}
					if(vec6_l>largest_edge){
						largest_edge = vec6_l;
					}


					edge_ratio = largest_edge/smallest_edge;

					if(edge_ratio > largest_edge_ratio){
						largest_edge_ratio = edge_ratio;
					}

				


			///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				


			/////////////////////////////////////////////////////////////////////////////////////////////////



		

	
}
}

cout << "final min/max dihedral angle " << min_d_ang*180/param.pi << " " << max_d_ang*180/param.pi << endl;


		cout << "final largest edge ratio " << largest_edge_ratio << endl;


}