#include "stdafx.h"


void get_sizes(char filename_node[], char filename_ele[], long &nodes_number, long &tets_number){

	ifstream in_stream;

	in_stream.open(filename_node);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	in_stream >> nodes_number;

	in_stream.close();


	in_stream.open(filename_ele);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	in_stream >> tets_number;

	in_stream.close();


}


void load_nodes( char filename_node[], parameters &param){

	float blank;

	ifstream in_stream;

	in_stream.open(filename_node);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	//the first number in the file should be the number of nodes;

	in_stream >> param.nodes_number;
	in_stream >> blank;


	for(long n=0 ; n< param.nodes_number ; n++){
		in_stream >> blank;
		in_stream >> param.n_x[n];
		in_stream >> param.n_y[n];
		in_stream >> param.n_z[n];
	};

	//cout << nodes_array[0] << " " << nodes_array[1] << " " << nodes_array[2] << endl;
	//cout << nodes_array[3] << " " << nodes_array[4] << " " << nodes_array[5] << endl;
	//exit(1);

	in_stream.close();


}

void load_tets( char filename_ele[], parameters &param){

	long blank;

	ifstream in_stream;

	in_stream.open(filename_ele);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	//the first number in the file should be the number of nodes;

	in_stream >> param.tets_number;
	in_stream >> blank;
	in_stream >> blank;

	for(long n=0 ; n< param.tets_number ; n++){
		in_stream >> blank;
		in_stream >> param.t_1[n];
		in_stream >> param.t_2[n];
		in_stream >> param.t_3[n];
		in_stream >> param.t_4[n];
		in_stream >> param.t_r[n];
		param.t_1[n]=param.t_1[n]-1;
		param.t_2[n]=param.t_2[n]-1;
		param.t_3[n]=param.t_3[n]-1;
		param.t_4[n]=param.t_4[n]-1;


	};

	in_stream.close();

}




void load_signed_distance_function(char filename_level_set[], float signed_dist_array[], parameters &param){


	long s3D;

	if(param.zoom_level == 1){
		s3D = param.size3Dl;
	}
	if(param.zoom_level == 2){
		s3D = param.size3Dl_z2;
	}
	if(param.zoom_level == 3){
		s3D = param.size3Dl_z3;
	}

	ifstream in_stream;

	in_stream.open(filename_level_set);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	for(long n=0;n<s3D;n++){
		in_stream >> signed_dist_array[n];
	};

	in_stream.close();


}



void load_regions(char filename_regions[], short regions_array[], parameters &param){


	long s3D;

	if(param.zoom_level == 1){
		s3D = param.size3D;
	}
	if(param.zoom_level == 2){
		s3D = param.size3D_z2;
	}
	if(param.zoom_level == 3){
		s3D = param.size3D_z3;
	}

	ifstream in_stream;

	in_stream.open(filename_regions);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	for(long n=0;n<s3D;n++){
		in_stream >> regions_array[n];
	};

	in_stream.close();


}



void output(  parameters &param, char filename1[], char filename2[]){

	
	short *nodes_ok;
	long converter;
	converter = 0;
	long size;
	size = 0;

	long p1, p2, p3, p4, r;

	//nodes_ok is 1 if node is part of at least one tet, otherwise it's 0

	/*
	nodes_ok = new short[param.nodes_number];

	for(long n=0;n<param.nodes_number;n++){
		nodes_ok[n] = 0;
	}


	for(long n=0;n<param.tets_number; n++){

		p1=param.t_1[n];
		p2=param.t_2[n];
		p3=param.t_3[n];
		p4=param.t_4[n];
		r=param.t_r[n];

		if(r != 0){
			nodes_ok[p1] = 1;
			nodes_ok[p2] = 1;
			nodes_ok[p3] = 1;
			nodes_ok[p4] = 1;
		}

	}

	for(long n=0;n<param.nodes_number;n++){
		size = size + nodes_ok[n];
	}
	*/


	ofstream out_stream;

	out_stream.open(filename1);

	out_stream << param.nodes_number << " 3" << endl;

	for(long n=0;n<param.nodes_number;n++){

		//if(nodes_ok[n] == 1){

			out_stream << (n+1) << " " << param.n_x[n] << " " << param.n_y[n] << " " << param.n_z[n] << endl;
			//converter = converter+1;

		//}

	}

	out_stream.close();

	/*

	long print_tets_number = 0;
	long counter = 0;
	for(long n=0;n<tets_number;n++){
		print_tets_number = print_tets_number + tets_array[n*5+4];
	};

	out_stream.open(filename2);

	out_stream << print_tets_number << " " << 4 << " " << 1 << endl;

	for(long n=0;n<tets_number;n++){

		if(tets_array[n*5+4] == 1){
			counter = counter + 1;

		out_stream << counter << " " << tets_array[n*5+0] << " " << tets_array[n*5+1] << " " << tets_array[n*5+2] << " " << tets_array[n*5+3] << " " << tets_array[n*5+4] << endl;
		}

	}

	*/


	
	/*
	out_stream.open(filename2);

	out_stream << param.tets_number << " " << 4 << " " << 1 << endl;

	for(long n=0;n<param.tets_number;n++){

		out_stream << (n+1) << " " << param.t_1[n]+1 << " " << param.t_2[n]+1 << " " << param.t_3[n]+1 << " " << param.t_4[n]+1 << " " << param.t_r[n] << endl;

	}

	out_stream.close();
	*/
	
	







}


/*
void output2(  parameters &param, char filename1[], char filename2[]){

	

	ofstream out_stream;

	out_stream.open(filename1);

	out_stream << param.nodes_number << " 3" << endl;

	for(long n=0;n<param.nodes_number;n++){

		out_stream << (n+1) << " " << param.n_x[n] << " " << param.n_y[n] << " " << param.n_z[n] << endl;

	}

	out_stream.close();


	long print_tets_number = 0;
	long counter = 0;
	for(long n=0;n<param.tets_number;n++){
		if(tets[n*5+4] == param.region_print ){
			print_tets_number = print_tets_number + 1;
		};
	};

	out_stream.open(filename2);

	out_stream << print_tets_number << " " << 4 << " " << 1 << endl;

	for(long n=0;n<param.tets_number;n++){

		if(tets[n*5+4] == param.region_print ){
			counter = counter + 1;

		out_stream << counter << " " << tets[n*5+0]+1 << " " << tets[n*5+1]+1 << " " << tets[n*5+2]+1 << " " << tets[n*5+3]+1 << " " << tets[n*5+4] << endl;
		}

	}

	


	

}
*/

void load_gradients(float gradient_field_x[], float gradient_field_y[], float gradient_field_z[], char filename_vec_x[], char filename_vec_y[], char filename_vec_z[], long size){



	ifstream in_stream;

	in_stream.open(filename_vec_x);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	for(long n=0;n<size;n++){
		in_stream >> gradient_field_x[n];
	};

	in_stream.close();

	//
	in_stream.open(filename_vec_y);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	for(long n=0;n<size;n++){
		in_stream >> gradient_field_y[n];
	};

	in_stream.close();
	//

	in_stream.open(filename_vec_z);
	if (in_stream.fail()){
		cout << "Input file opening failed" << endl;
		exit(1);
	};

	for(long n=0;n<size;n++){
		in_stream >> gradient_field_z[n];
	};

	in_stream.close();


}


void print_F(long t, parameters &param){

	ofstream out_stream;

	out_stream.open(param.file_F);

	out_stream << "F=zeros("<< t << ",1);" << endl;

	for(long n=0;n<t;n++){

		out_stream << "F(" << (n+1) << ",1)=" << param.F[n] << ";" << endl;

	}

	out_stream << "plot(F);" << endl;

	out_stream << " " << endl;

	out_stream << "G=zeros(" << t << ",1);" << endl;

	for(long n=0;n<t;n++){

		out_stream << "G(" << (n+1) << ",1)=" << param.G[n] << ";" << endl;

	}

	out_stream << "figure" << endl;

	out_stream << "plot(G);" << endl;



	out_stream.close();

}




void output_faces( face face_class[], parameters &param, char filename1[]){

	long counter;
	counter = 0;
	long out_num;
	out_num = 0;

	for(long n=0;n<param.faces_number;n++){
		if(face_class[n].region != 0){
			out_num = out_num + 1;
		}
	}



	ofstream out_stream;

	out_stream.open(filename1);

	out_stream << out_num << " 1" << endl;

	
	for(long n=0;n<param.faces_number;n++){
		if(face_class[n].region != 0){

			counter = counter+1;
			out_stream << counter << " " << face_class[n].node1+1 << " " << face_class[n].node2+1 << " " << face_class[n].node3+1 << " " << face_class[n].region  << endl;

		}
	}

	out_stream.close();

}