// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once


#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <math.h>
#include "parameters.h"
#include "node_info.h"
#include "face.h"
#include "iostream"
#include "fstream"
#include "iomanip"
#include <iostream>
#include <iomanip>
#include <algorithm>
using namespace std;


//definitions

#define ACCESS_3BY3(a,i,j) a[(i)+3*(j)]
#define temp_(i,j) ACCESS_3BY3(temp,i,j)
#define input_(i,j) ACCESS_3BY3(input,i,j)
#define dx_(i,j) ACCESS_3BY3(dx,i,j)
#define dX_(i,j) ACCESS_3BY3(dX,i,j)
#define F_(i,j) ACCESS_3BY3(F,i,j)
#define inv3_dX_(i,j) ACCESS_3BY3(inv3_dX,i,j)
#define v_calc_matrix_(i,j) ACCESS_3BY3(v_calc_matrix,i,j)
#define I_(i,j) ACCESS_3BY3(I,i,j)
#define b_(i,j) ACCESS_3BY3(b,i,j)
#define sigma_(i,j) ACCESS_3BY3(sigma,i,j)
#define P_(i,j) ACCESS_3BY3(P,i,j)
#define ftwo_fthree_ffour_(i,j) ACCESS_3BY3(ftwo_fthree_ffour,i,j)
#define M_(i,j) ACCESS_3BY3(M,i,j)
#define A_(i,j) ACCESS_3BY3(A,i,j)
#define B_(i,j) ACCESS_3BY3(B,i,j)
#define M1_(i,j) ACCESS_3BY3(M1,i,j)
#define M2_(i,j) ACCESS_3BY3(M2,i,j)
#define M3_(i,j) ACCESS_3BY3(M3,i,j)
#define M4_(i,j) ACCESS_3BY3(M4,i,j)
#define G_(i,j) ACCESS_3BY3(G,i,j)
#define S_(i,j) ACCESS_3BY3(S,i,j)
#define trans3_F_(i,j) ACCESS_3BY3(trans3_F,i,j)
#define inv3_dx_(i,j) ACCESS_3BY3(inv3_dx,i,j)


#define ACCESS_2BY2(a,i,j) a[(i)+2*(j)]
#define N_(i,j) ACCESS_2BY2(N,i,j)
#define N1_(i,j) ACCESS_2BY2(N1,i,j)
#define N2_(i,j) ACCESS_2BY2(N2,i,j)
#define N3_(i,j) ACCESS_2BY2(N3,i,j)
#define N4_(i,j) ACCESS_2BY2(N4,i,j)
#define N5_(i,j) ACCESS_2BY2(N5,i,j)
#define N6_(i,j) ACCESS_2BY2(N6,i,j)
#define N7_(i,j) ACCESS_2BY2(N7,i,j)
#define N8_(i,j) ACCESS_2BY2(N8,i,j)
#define N9_(i,j) ACCESS_2BY2(N9,i,j)



#define ACCESS_NODES(a,i,j) a[3*i+j]
#define nodes_(i,j) ACCESS_NODES(nodes,i,j)
#define elastic_node_forces_(i,j) ACCESS_NODES(elastic_node_forces,i,j)
#define level_set_node_forces_(i,j) ACCESS_NODES(level_set_node_forces,i,j)
#define smoothing_node_forces_(i,j) ACCESS_NODES(smoothing_node_forces,i,j)
#define node_forces_(i,j) ACCESS_NODES(node_forces,i,j)
#define nodes_p1_(i,j) ACCESS_NODES(nodes_p1,i,j) 
#define node_boundary_vectors_(i,j) ACCESS_NODES(node_boundary_vectors,i,j)




#define ACCESS_TETS(a,i,j) a[5*i+j]
#define tets_(i,j) ACCESS_TETS(tets,i,j)


#define ACCESS_IMAGE(a,i,j,k) a[i+param.size1D_x*(j)+param.size1D_x*param.size1D_y*(k)]
#define signed_dist_array_(i,j,k) ACCESS_IMAGE(signed_dist_array,i,j,k)
#define regions_array_(i,j,k) ACCESS_IMAGE(regions_array,i,j,k)
#define singleton_array_(i,j,k) ACCESS_IMAGE(singleton_array,i,j,k)
#define fewn_array_(i,j,k) ACCESS_IMAGE(fewn_array,i,j,k)

#define x_dir_(i,j,k) ACCESS_IMAGE(x_dir,i,j,k)
#define y_dir_(i,j,k) ACCESS_IMAGE(y_dir,i,j,k)
#define z_dir_(i,j,k) ACCESS_IMAGE(z_dir,i,j,k)

//note l is the region number.  
#define ACCESS_VECTOR_FIELD(a,i,j,k,l) a[i+param.size1D_x*(j)+param.size1D_x*param.size1D_y*(k)+param.size3D*(l)]
#define gradient_field_x_(i,j,k,l) ACCESS_VECTOR_FIELD(gradient_field_x,i,j,k,l)
#define gradient_field_y_(i,j,k,l) ACCESS_VECTOR_FIELD(gradient_field_y,i,j,k,l)
#define gradient_field_z_(i,j,k,l) ACCESS_VECTOR_FIELD(gradient_field_z,i,j,k,l)

#define ACCESS_BOUNDARY_OF(a,i,j) a[i+boundary_number*(j)]
#define boundary_of_(i,j) ACCESS_BOUNDARY_OF(boundary_of,i,j)

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define trace3_(input) (input[0]+input[4]+input[8]);

#define eye3_(M) M[0]= 1.0; M[3]= 0; M[6]= 0; M[1]= 0; M[4]= 1.0; M[7]= 0; M[2]= 0; M[5]= 0; M[8]= 1.0;

#define transpose3_(input, M) M[0]= input[0]; M[3]= input[1]; M[6]= input[2]; M[1]= input[3]; M[4]= input[4]; M[7]= input[5]; M[2]= input[6]; M[5]= input[7]; M[8]= input[8];

//#define add3_(A,B,M) M[0]=A[0]+B[0]; M[1]=A[1]+B[1]; M[2]=A[2]+B[2]; M[3]=A[3]+B[3]; M[4]=A[4]+B[4]; M[5]=A[5]+B[5]; M[6]=A[6]+B[6]; M[7]=A[7]+B[7]; M[8]=A[8]+B[8]; 
#define add3_(A,B) A[0]+=B[0]; A[1]+=B[1]; A[2]+=B[2]; A[3]+=B[3]; A[4]+=B[4]; A[5]+=B[5]; A[6]+=B[6]; A[7]+=B[7]; A[8]+=B[8]; 

//#define m_const3_(input, constant, M) M[0] = constant*input[0]; M[1] = constant*input[1]; M[2] = constant*input[2]; M[3] = constant*input[3]; M[4] = constant*input[4]; M[5] = constant*input[5]; M[6] = constant*input[6]; M[7] = constant*input[7]; M[8] = constant*input[8]; 
#define m_const3_(input, constant) input[0] *= constant; input[1] *= constant; input[2] *= constant; input[3] *= constant; input[4] *= constant; input[5] *= constant; input[6] *= constant; input[7] *= constant; input[8] *= constant; 

#define add_const3_(input, constant) input[0] += constant; input[1] += constant; input[2] += constant; input[3] += constant; input[4] += constant; input[5] += constant; input[6] += constant; input[7] += constant; input[8] += constant; 


/*
#define det3_(input, det3, param)  \
	param.N1[0] = input[4];\
	param.N1[2] = input[7];\
	param.N1[1] = input[5];\
	param.N1[3] = input[8];\
	param.N2[0] = input[1];\
	param.N2[2] = input[7];\
	param.N2[1] = input[2];\
	param.N2[3] = input[8];\
	param.N3[0] = input[1];\
	param.N3[2] = input[4];\
	param.N3[1] = input[2];\
	param.N3[3] = input[5];\
	det3 = input[0]*(param.N1[0]*param.N1[3] - param.N1[2]*param.N1[1]) - input[3]*(param.N2[0]*param.N2[3] - param.N2[2]*param.N2[1]) + input[6]*(param.N3[0]*param.N3[3] - param.N3[2]*param.N3[1]);\
*/

#define det3_(input, det3, param)\
det3 = input[0]*(input[4]*input[8] - input[7]*input[5]) - input[3]*(input[1]*input[8] - input[7]*input[2]) + input[6]*(input[1]*input[5] - input[4]*input[2]);\


#define inv3_(input, det3, M, param)\
	M[0]= (input[4]*input[8] - input[7]*input[5])/det3;\
	M[3]= (input[6]*input[5] - input[3]*input[8])/det3;\
	M[6]= (input[3]*input[7] - input[6]*input[4])/det3;\
	M[1]= (input[7]*input[2] - input[1]*input[8])/det3;\
	M[4]= (input[0]*input[8] - input[6]*input[2])/det3;\
	M[7]= (input[6]*input[1] - input[0]*input[7])/det3;\
	M[2]= (input[1]*input[5] - input[4]*input[2])/det3;\
	M[5]= (input[3]*input[2] - input[0]*input[5])/det3;\
	M[8]= (input[0]*input[4] - input[3]*input[1])/det3;\


/*
#define inv3_(input, M, param)  \
\
	param.N1[0]=input[4];\
	param.N1[2]=input[7];\
	param.N1[1]=input[5];\
	param.N1[3]=input[8];\
\
	param.N2[0]=input[6];\
	param.N2[2]=input[3];\
	param.N2[1]=input[8];\
	param.N2[3]=input[5];\
\
	param.N3[0]=input[3];\
	param.N3[2]=input[6];\
	param.N3[1]=input[4];\
	param.N3[3]=input[7];\
\
	param.N4[0]=input[7];\
	param.N4[2]=input[1];\
	param.N4[1]=input[8];\
	param.N4[3]=input[2];\
\
	param.N5[0]=input[0];\
	param.N5[2]=input[6];\
	param.N5[1]=input[2];\
	param.N5[3]=input[8];\
\
	param.N6[0]=input[6];\
	param.N6[2]=input[0];\
	param.N6[1]=input[7];\
	param.N6[3]=input[1];\
\
	param.N7[0]=input[1];\
	param.N7[2]=input[4];\
	param.N7[1]=input[2];\
	param.N7[3]=input[5];\
\
	param.N8[0]=input[3];\
	param.N8[2]=input[0];\
	param.N8[1]=input[5];\
	param.N8[3]=input[2];\
\
	param.N9[0]=input[0];\
	param.N9[2]=input[3];\
	param.N9[1]=input[1];\
	param.N9[3]=input[4];\
 \
	param.temp[0]= param.N1[0]*param.N1[3] - param.N1[2]*param.N1[1];\
	param.temp[3]= param.N2[0]*param.N2[3] - param.N2[2]*param.N2[1];\
	param.temp[6]= param.N3[0]*param.N3[3] - param.N3[2]*param.N3[1];\
	param.temp[1]= param.N4[0]*param.N4[3] - param.N4[2]*param.N4[1];\
	param.temp[4]= param.N5[0]*param.N5[3] - param.N5[2]*param.N5[1];\
	param.temp[7]= param.N6[0]*param.N6[3] - param.N6[2]*param.N6[1];\
	param.temp[2]= param.N7[0]*param.N7[3] - param.N7[2]*param.N7[1];\
	param.temp[5]= param.N8[0]*param.N8[3] - param.N8[2]*param.N8[1];\
	param.temp[8]= param.N9[0]*param.N9[3] - param.N9[2]*param.N9[1];\
\
	det3_(input,param.temp_det,param)\
\
	M[0]= param.temp[0]/param.temp_det;\
	M[3]= param.temp[3]/param.temp_det;\
	M[6]= param.temp[6]/param.temp_det;\
	M[1]= param.temp[1]/param.temp_det;\
	M[4]= param.temp[4]/param.temp_det;\
	M[7]= param.temp[7]/param.temp_det;\
	M[2]= param.temp[2]/param.temp_det;\
	M[5]= param.temp[5]/param.temp_det;\
	M[8]= param.temp[8]/param.temp_det;\
*/
#define m3_(A, B, M)\
\
	M[0]=A[0]*B[0]+A[3]*B[1]+A[6]*B[2];\
	M[3]=A[0]*B[3]+A[3]*B[4]+A[6]*B[5];\
	M[6]=A[0]*B[6]+A[3]*B[7]+A[6]*B[8];\
\
	M[1]=A[1]*B[0]+A[4]*B[1]+A[7]*B[2];\
	M[4]=A[1]*B[3]+A[4]*B[4]+A[7]*B[5];\
	M[7]=A[1]*B[6]+A[4]*B[7]+A[7]*B[8];\
\
	M[2]=A[2]*B[0]+A[5]*B[1]+A[8]*B[2];\
	M[5]=A[2]*B[3]+A[5]*B[4]+A[8]*B[5];\
	M[8]=A[2]*B[6]+A[5]*B[7]+A[8]*B[8];\

	
#define m3_AAT_(A, M)\
\
	M[0]=A[0]*A[0]+A[3]*A[3]+A[6]*A[6];\
	M[3]=A[0]*A[1]+A[3]*A[4]+A[6]*A[7];\
	M[6]=A[0]*A[2]+A[3]*A[5]+A[6]*A[8];\
\
	M[1]=M[3];\
	M[4]=A[1]*A[1]+A[4]*A[4]+A[7]*A[7];\
	M[7]=A[1]*A[2]+A[4]*A[5]+A[7]*A[8];\
\
	M[2]=M[6];\
	M[5]=M[7];\
	M[8]=A[2]*A[2]+A[5]*A[5]+A[8]*A[8];\

#define m3_ATA_(A, M)\
\
	M[0]=A[0]*A[0]+A[1]*A[1]+A[2]*A[2];\
	M[3]=A[0]*A[3]+A[1]*A[4]+A[2]*A[5];\
	M[6]=A[0]*A[6]+A[1]*A[7]+A[2]*A[8];\
\
	M[1]=M[3];\
	M[4]=A[3]*A[3]+A[4]*A[4]+A[5]*A[5];\
	M[7]=A[3]*A[6]+A[4]*A[7]+A[5]*A[8];\
\
	M[2]=M[6];\
	M[5]=M[7];\
	M[8]=A[6]*A[6]+A[7]*A[7]+A[8]*A[8];\





#define psd_inv3_(input, M, param)\
\
	transpose3_(input,param.M1);\
\
		m3_(param.M1,input,param.M2);\
\
	param.M2[0]=param.M2[0] + param.psd;\
	param.M2[4]=param.M2[4] + param.psd;\
	param.M2[8]=param.M2[8] + param.psd;\
\
		det3_(param.M2,param.temp_det,param);\
		inv3_(param.M2,param.temp_det,param.M3,param);\
		\
		m3_(param.M3,param.M1,M);\



//////////////////////////////////////////////////////////////

#define add_entry_s_(A, row_in, column_in, val_in)\
	\
	if(row_in == column_in){\
		A.diags[row_in] = A.diags[row_in]+val_in;\
	}else{\
		if(row_in > column_in){\
\
			A.ue[A.se[A.sm_entry_count].sort].val=A.ue[A.se[A.sm_entry_count].sort].val + val_in;\
			A.ue[A.se[A.sm_entry_count].sort].order_number= column_in+row_in*A.length;\
			A.ue[A.se[A.sm_entry_count].sort].row = row_in;\
			A.ue[A.se[A.sm_entry_count].sort].column = column_in;\
\
		}else{\
\
			A.ue[A.se[A.sm_entry_count].sort].val=A.ue[A.se[A.sm_entry_count].sort].val + val_in;\
			A.ue[A.se[A.sm_entry_count].sort].order_number= row_in+column_in*A.length;\
			A.ue[A.se[A.sm_entry_count].sort].row = column_in;\
			A.ue[A.se[A.sm_entry_count].sort].column = row_in;\
\
		}\
\
		A.sm_entry_count = A.sm_entry_count + 1;\
\
	}\




	
	
	
	
	
	 
	
// TODO: reference additional headers your program requires here
