#include "stdafx.h"



#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"


///////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////


void initialize_coordinate_array(float x_coordinate_array_grid1[], float y_coordinate_array_grid1[], float z_coordinate_array_grid1[],
								 float x_coordinate_array_grid2[], float y_coordinate_array_grid2[], float z_coordinate_array_grid2[],parameters &param){

	//The numbering of the grid will be done as follows:
	//the node at x_min, y_min, z_min will be 1.
	//I'll move forward until the end of the row,
	//then start counting on the row to the right
	//once that plane is completed, i'll move up.


	//In this algorithm, to move one forward, i add 1.
	//To move right, iI add x_nodes
	//To move up I add x_nodes*y_nodes
	//For example, if I had a 10 by 100 by 6212 grid,
	//add 1 to move forward, 10 to move right, 1000 to move up.

	long move_forward = 1;
	long move_right = param.x_nodes;
	long move_up = param.x_nodes*param.y_nodes;
	long index;



	for (long k=0; k < param.z_nodes; k++){
	for (long j=0; j < param.y_nodes; j++){
	for (long i=0; i < param.x_nodes; i++){


		index = i*move_forward + move_right*j + move_up*k;


		x_coordinate_array_grid1[index] = param.x_min + float(i)*param.grid_space;
		y_coordinate_array_grid1[index] = param.y_min + float(j)*param.grid_space;
		z_coordinate_array_grid1[index] = param.z_min + float(k)*param.grid_space;

		//cout << param.x_min + float(i)*param.grid_space << endl;


	};
	};
	};

	//the procedure is similar for the second grid, but all
	//node locations are increased by 1/2 a gridspace
	//in all directions.  

	for (long k=0; k < param.z_nodes; k++){
	for (long j=0; j < param.y_nodes; j++){
	for (long i=0; i < param.x_nodes; i++){



		index = i*move_forward + move_right*j + move_up*k;


		x_coordinate_array_grid2[index] = param.x_min + (float(i)+.5)*param.grid_space;
		y_coordinate_array_grid2[index] = param.y_min + (float(j)+.5)*param.grid_space;
		z_coordinate_array_grid2[index] = param.z_min + (float(k)+.5)*param.grid_space;

	};
	};
	};




};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//the elements of grid1 are numbered 0 to (nodes.grid1.number - 1) 
	//and that the elements of grid2 are numbered nodes_grid1_number to (nodes_grid1_number + nodes_grid2_number - 1);

void initialize_node_array(long node_array_grid1[], long node_array_grid2[],parameters &param){
	

	for( long n=0; n<=(param.nodes_grid1_number - 1); n++){

		node_array_grid1[n]=n;

	};

	for( long n=0; n<=(param.nodes_grid2_number - 1); n++){

		node_array_grid2[n]=n + param.nodes_grid1_number;

	};

}



////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////


void initialize_tet_array(long tet_array_initial[],parameters &param){


	for( long n=0; n<=(param.initial_tet_number - 1); n++){

		tet_array_initial[n]=n;

	};

}


 /////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////


void new_node_array(long node_array_size, long new_node_array[], float new_x_coordinate_array[], float new_y_coordinate_array[], float new_z_coordinate_array[], node node_class_array_input[], edge edge_class_array[], long edge_class_array_size, tet tet_class_array[] , long tet_class_array_size){

	long p1;
	long p2;
	float x1;
	float y1;
	float z1;
	float x2;
	float y2;
	float z2;
	float x3;
	float y3;
	float z3;

	long m=0;

	for( long n=0; n < edge_class_array_size; n++){



		if(edge_class_array[n].edge_split == to_split1){


			p1 = *edge_class_array[n].node1;
			p2 = *edge_class_array[n].node2;

			x1 = *node_class_array_input[p1].x;
			y1 = *node_class_array_input[p1].y;
			z1 = *node_class_array_input[p1].z;

			x2 = *node_class_array_input[p2].x;
			y2 = *node_class_array_input[p2].y;
			z2 = *node_class_array_input[p2].z;

			x3 = (x1 + x2)/2.0;
			y3 = (y1 + y2)/2.0;
			z3 = (z1 + z2)/2.0;

			new_node_array[m] = m + node_array_size;
			new_x_coordinate_array[m] = x3;
			new_y_coordinate_array[m] = y3;
			new_z_coordinate_array[m] = z3;

			edge_class_array[n].set_have_split1 ();
			edge_class_array[n].set_use_split_false ();
			edge_class_array[n].add_split_node(m, new_node_array);

			m=m+1;

		}

	};



}


///////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////


void new_edge_array(long edge_array[], long edge_array_size, long previous_edge_array_size){


	for( long n=0; n< edge_array_size; n++){

		edge_array[n] = n + previous_edge_array_size;

	};

}

////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////


void new_tet_array(long new_tet_array[], long new_tet_array_size, long tet_array_size){


	for( long n=0; n< new_tet_array_size; n++){

		new_tet_array[n] = n + tet_array_size;

	};

}

void new_face_array(long new_face_array[], long new_face_array_size, long previous_face_array_size){


	for( long n=0; n< new_face_array_size; n++){

		new_face_array[n] = n + previous_face_array_size;

	};

}







