#include "stdafx.h"



#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"
#include "hexa.h"


// the 1 means the function initializes nodes in grid1.  the 2 means the function initializes nodes in grid2


void node::initialize_node1 (long node_number_input, float x_coordinate_array_grid1[], float y_coordinate_array_grid1[], float z_coordinate_array_grid1[], long node_array_grid1[]){

	node_number = &node_array_grid1[node_number_input];

	x = &x_coordinate_array_grid1[node_number_input];
	y = &y_coordinate_array_grid1[node_number_input];
	z = &z_coordinate_array_grid1[node_number_input];

	//at first the node will be marked as removed.  once the node is assigned to a tet, it will be marked as true.  the reason
	//for this is that extra unwanted nodes are created on the boundary.

	removed = true;

	//edge_belong_number = 0;
	edge_belong_entered = 0;
	//face_belong_number = 0;
	face_belong_entered = 0;



}

void node::initialize_node2 (long node_number_input, float x_coordinate_array_grid2[], float y_coordinate_array_grid2[], float z_coordinate_array_grid2[], long node_array_grid2[],parameters &param){

	node_number = &node_array_grid2[node_number_input];

	x = &x_coordinate_array_grid2[node_number_input];
	y = &y_coordinate_array_grid2[node_number_input];
	z = &z_coordinate_array_grid2[node_number_input];

	removed = true;

	//edge_belong_number = 0;
	edge_belong_entered = 0;
	//face_belong_number = 0;
	face_belong_entered = 0;


}


void node::set_remove_false(){

	removed = false;

}

void node::set_remove_true (){

	removed = true;

}

void node::new_node(long this_node_number, long new_node_array[], float new_x_coordinate_array[], float new_y_coordinate_array[], float new_z_coordinate_array[]){

	node_number = &new_node_array[this_node_number];
	x = &new_x_coordinate_array[this_node_number];
	y = &new_y_coordinate_array[this_node_number];
	z = &new_z_coordinate_array[this_node_number];

	removed = false;

	//edge_belong_number = 0;
	edge_belong_entered = 0;
	//face_belong_number = 0;
	face_belong_entered = 0;

	for(short m=0;m<8;m++){
		diag_bdry_share[m]=-1;
	}

}

void node::set_edge_belong_number0 (){

	//edge_belong_number = 0;
	edge_belong_entered = 0;


}

void node::set_face_belong_number0 (){

	//face_belong_number = 0;
	face_belong_entered = 0;


}

//void node::edge_belong_number_p1 (){

//	edge_belong_number = edge_belong_number + 1;

//}

//void node::face_belong_number_p1 (){

//	face_belong_number = face_belong_number + 1;

//}

void node::add_edge_belong (long *ptr_to_edge_number){

	if(edge_belong_entered != 0){
		long **temp_array;
		temp_array = new long*[edge_belong_entered];

		for(long n=0;n<edge_belong_entered;n++){
			temp_array[n]=edge_belong[n];
		};

		delete [] edge_belong;
		edge_belong = new long*[edge_belong_entered+1];
		for(long n=0;n<edge_belong_entered;n++){
			edge_belong[n]=temp_array[n];
		};
		delete [] temp_array;
	}
	else{
		edge_belong = new long*[1];
	};
	edge_belong[edge_belong_entered] = ptr_to_edge_number;	
	edge_belong_entered=edge_belong_entered+1;

}



void node::add_face_belong (long *ptr_to_face_number){


	if(face_belong_entered != 0){
		long **temp_array;
		temp_array = new long*[face_belong_entered];

		for(long n=0;n<face_belong_entered;n++){
			temp_array[n]=face_belong[n];
		};

		delete [] face_belong;
		face_belong = new long*[face_belong_entered+1];
		for(long n=0;n<face_belong_entered;n++){
			face_belong[n]=temp_array[n];
		};
		delete [] temp_array;
		}
	else{
		face_belong = new long*[1];
	};
	face_belong[face_belong_entered] = ptr_to_face_number;
	face_belong_entered=face_belong_entered+1;
	
}

//void node::set_edge_belong_size(){

	//edge_belong = new long*[edge_belong_number];

//}

//void node::set_face_belong_size(){

//	face_belong = new long*[face_belong_number];

//}

void node::empty_hexa(){


	for(short m=0;m<8;m++){
		hexa_belong[m] = -1;
	}

}

void node::add_hexa(long hexa_number){

	if(hexa_belong[0] == -1){
		hexa_belong[0]=hexa_number;
	}else{
		if(hexa_belong[1] == -1){
			hexa_belong[1]=hexa_number;
		}else{
			if(hexa_belong[2] == -1){
				hexa_belong[2]=hexa_number;
			}else{
				if(hexa_belong[3] == -1){
					hexa_belong[3]=hexa_number;
				}else{
					if(hexa_belong[4] == -1){
						hexa_belong[4]=hexa_number;
					}else{
						if(hexa_belong[5] == -1){
							hexa_belong[5]=hexa_number;
						}else{
							if(hexa_belong[6] == -1){
								hexa_belong[6]=hexa_number;
							}else{
								hexa_belong[7]=hexa_number;
							}
						}
					}
				}
			}
		}
	}
	
}

