#include "stdafx.h"
#include <fstream>
#include "parameters.h"
#include <math.h>

#include "hexa.h"
#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"
#include "face.h"

using namespace std;

short region(float x, float y, float z,  short region_array[],parameters &param, short zoom_level);

void pre_initialize_hexa(hexa hexa_class_array[], node node_class_array[], long hexa_size, long node_size);
void pre_initialize_node_for_hexa(node node_class_array[], long node_size);
long hex_entered(long node1, long node2, node node_class_array[]);

float vec_length(float vec[]);


void get_regions(tet tet_class_array[],long tet_class_array_size, tet tet_class_array_red[], long tet_class_array_red_size, tet tet_class_array_green[], long tet_class_array_green_size, node node_class_array[], short regions_array[],parameters &param, short zoom_level){

	long pp[4];
	float xx[4];
	float yy[4];
	float zz[4];
	short r[4];
	short region_input;

	for(long q=0; q<tet_class_array_size; q++){
	if(tet_class_array[q].removed == false){

		pp[0] = *tet_class_array[q].node1;
		pp[1] = *tet_class_array[q].node2;
		pp[2] = *tet_class_array[q].node3;
		pp[3] = *tet_class_array[q].node4;

		for (long u=0; u<4; u++){

			xx[u] = *node_class_array[pp[u]].x;
			yy[u] = *node_class_array[pp[u]].y;
			zz[u] = *node_class_array[pp[u]].z;

		};

		for (long u=0;u<4;u++){
			r[u] = region(xx[u], yy[u], zz[u], regions_array, param, zoom_level);
		}

		region_input = max( max( max(r[0],r[1]), r[2]), r[3]) ;
		tet_class_array[q].set_region(region_input);
	};
	};



//

	if(param.use_lite == false){

for(long q=0; q<tet_class_array_red_size; q++){
	if(tet_class_array_red[q].removed == false){

		pp[0] = *tet_class_array_red[q].node1;
		pp[1] = *tet_class_array_red[q].node2;
		pp[2] = *tet_class_array_red[q].node3;
		pp[3] = *tet_class_array_red[q].node4;

		for (long u=0; u<4; u++){

			xx[u] = *node_class_array[pp[u]].x;
			yy[u] = *node_class_array[pp[u]].y;
			zz[u] = *node_class_array[pp[u]].z;

		};

		for (long u=0;u<4;u++){
			r[u] = region(xx[u], yy[u], zz[u], regions_array, param, zoom_level);
		}

		region_input = max( max( max(r[0],r[1]), r[2]), r[3]) ;
		tet_class_array_red[q].set_region(region_input);
	};
};


//

for(long q=0; q<tet_class_array_green_size; q++){
	if(tet_class_array_green[q].removed == false){

		pp[0] = *tet_class_array_green[q].node1;
		pp[1] = *tet_class_array_green[q].node2;
		pp[2] = *tet_class_array_green[q].node3;
		pp[3] = *tet_class_array_green[q].node4;

		for (long u=0; u<4; u++){

			xx[u] = *node_class_array[pp[u]].x;
			yy[u] = *node_class_array[pp[u]].y;
			zz[u] = *node_class_array[pp[u]].z;

		};

		for (long u=0;u<4;u++){
			r[u] = region(xx[u], yy[u], zz[u], regions_array, param, zoom_level);
		}

		region_input = max( max( max(r[0],r[1]), r[2]), r[3]) ;
		tet_class_array_green[q].set_region(region_input);
	};
};

///////////////////////////////////

	}else{

		for(long q=0; q<tet_class_array_red_size; q++){
			if(param.tet_class_array_red5[q].removed == false){


		pp[0] = *param.tet_class_array_red5[q].node1;
		pp[1] = *param.tet_class_array_red5[q].node2;
		pp[2] = *param.tet_class_array_red5[q].node3;
		pp[3] = *param.tet_class_array_red5[q].node4;

		for (long u=0; u<4; u++){

			xx[u] = *node_class_array[pp[u]].x;
			yy[u] = *node_class_array[pp[u]].y;
			zz[u] = *node_class_array[pp[u]].z;

		};

		for (long u=0;u<4;u++){
			r[u] = region(xx[u], yy[u], zz[u], regions_array, param, zoom_level);
		}

		region_input = max( max( max(r[0],r[1]), r[2]), r[3]) ;
		param.tet_class_array_red5[q].region = region_input;
	
		};
		}


//

for(long q=0; q<tet_class_array_green_size; q++){
	if(param.tet_class_array_green5[q].removed == false){

		pp[0] = *param.tet_class_array_green5[q].node1;
		pp[1] = *param.tet_class_array_green5[q].node2;
		pp[2] = *param.tet_class_array_green5[q].node3;
		pp[3] = *param.tet_class_array_green5[q].node4;

		for (long u=0; u<4; u++){

			xx[u] = *node_class_array[pp[u]].x;
			yy[u] = *node_class_array[pp[u]].y;
			zz[u] = *node_class_array[pp[u]].z;

		};

		for (long u=0;u<4;u++){
			r[u] = region(xx[u], yy[u], zz[u], regions_array, param, zoom_level);
		}

		region_input = max( max( max(r[0],r[1]), r[2]), r[3]) ;
		param.tet_class_array_green5[q].region =region_input;

};
}






	}

cout << "regions labeled" << endl;



}





void hexagonize(tet tet_class_array_red[], long tet_class_array_red_size, node node_class_array[], long node_class_array_size, short regions_array[],parameters &param, short zoom_level){

	long pp[4];
	float xx[4];
	float yy[4];
	float zz[4];

	short r[4];

	float e1[3],e2[3],e3[3],e4[3],e5[3],e6[3];
	float el1,el2,el3,el4,el5,el6;

	float dis;
	if(zoom_level == 1){
		dis = 1.0;
	}
	if(zoom_level == 2){
		dis = 2.0;
	}
	if(zoom_level == 3){
		dis = 4.0;
	}
	
//////////////////////////////////////////////////////////////////////////
//getting hexa size

//pre_initialize_node_for_hexa(node_class_array6, node_class_array6_size);


long hexa_size = 0;
short in_hexa;

if(param.use_lite == false){

for(long q=0; q<tet_class_array_red_size; q++){
	if(tet_class_array_red[q].removed == false){

		//cout << "hello" << endl;

		pp[0] = *tet_class_array_red[q].node1;
		pp[1] = *tet_class_array_red[q].node2;
		pp[2] = *tet_class_array_red[q].node3;
		pp[3] = *tet_class_array_red[q].node4;

		for (long u=0; u<4; u++){

			xx[u] = *node_class_array[pp[u]].x;
			yy[u] = *node_class_array[pp[u]].y;
			zz[u] = *node_class_array[pp[u]].z;

		};

		for (long u=0;u<4;u++){
			r[u] = region(xx[u], yy[u], zz[u], regions_array, param, zoom_level);
		}

		e1[0]=xx[3]-xx[0];
		e1[1]=yy[3]-yy[0];
		e1[2]=zz[3]-zz[0];

		el1=vec_length(e1);

		e2[0]=xx[2]-xx[0];
		e2[1]=yy[2]-yy[0];
		e2[2]=zz[2]-zz[0];

		el2=vec_length(e2);

		e3[0]=xx[1]-xx[0];
		e3[1]=yy[1]-yy[0];
		e3[2]=zz[1]-zz[0];

		el3=vec_length(e3);

		e4[0]=xx[3]-xx[1];
		e4[1]=yy[3]-yy[1];
		e4[2]=zz[3]-zz[1];

		el4=vec_length(e4);

		e5[0]=xx[3]-xx[2];
		e5[1]=yy[3]-yy[2];
		e5[2]=zz[3]-zz[2];

		el5=vec_length(e5);

		e6[0]=xx[2]-xx[1];
		e6[1]=yy[2]-yy[1];
		e6[2]=zz[2]-zz[1];

		el6=vec_length(e6);

		//cout << el1 << " " << el2 << " " << el3 << " " << el4 << " " << el5 << " " << el6 << endl;

		in_hexa = false;

		if( (el1==dis) && (r[0]!=r[3]) && (r[0] != -1) && (r[3] != -1) ){
			hexa_size=hexa_size+1;
		}
		if( (el2==dis) && (r[0]!=r[2]) && (r[0] != -1) && (r[2] != -1) ){
			hexa_size=hexa_size+1;
		}
		if( (el3==dis) && (r[0]!=r[1]) && (r[0] != -1) && (r[1] != -1) ){
			hexa_size=hexa_size+1;
		}
		if( (el4==dis) && (r[1]!=r[3]) && (r[1] != -1) && (r[3] != -1) ){
			hexa_size=hexa_size+1;
		}
		if( (el5==dis) && (r[2]!=r[3]) && (r[2] != -1) && (r[3] != -1) ){
			hexa_size=hexa_size+1;
		}
		if( (el6==dis) && (r[1]!=r[2]) && (r[1] != -1) && (r[2] != -1) ){
			hexa_size=hexa_size+1;
		}

		//region_input = max( max( max(r[0],r[1]), r[2]), r[3]) ;
		//tet_class_array_red5[q].set_region(region_input);
	};
};


}else{


	for(long q=0; q<tet_class_array_red_size; q++){
		if(param.tet_class_array_red5[q].removed == false){

		//cout << "hello" << endl;

		pp[0] = *param.tet_class_array_red5[q].node1;
		pp[1] = *param.tet_class_array_red5[q].node2;
		pp[2] = *param.tet_class_array_red5[q].node3;
		pp[3] = *param.tet_class_array_red5[q].node4;

		for (long u=0; u<4; u++){

			xx[u] = *node_class_array[pp[u]].x;
			yy[u] = *node_class_array[pp[u]].y;
			zz[u] = *node_class_array[pp[u]].z;

		};

		for (long u=0;u<4;u++){
			r[u] = region(xx[u], yy[u], zz[u], regions_array, param, zoom_level);
		}

		e1[0]=xx[3]-xx[0];
		e1[1]=yy[3]-yy[0];
		e1[2]=zz[3]-zz[0];

		el1=vec_length(e1);

		e2[0]=xx[2]-xx[0];
		e2[1]=yy[2]-yy[0];
		e2[2]=zz[2]-zz[0];

		el2=vec_length(e2);

		e3[0]=xx[1]-xx[0];
		e3[1]=yy[1]-yy[0];
		e3[2]=zz[1]-zz[0];

		el3=vec_length(e3);

		e4[0]=xx[3]-xx[1];
		e4[1]=yy[3]-yy[1];
		e4[2]=zz[3]-zz[1];

		el4=vec_length(e4);

		e5[0]=xx[3]-xx[2];
		e5[1]=yy[3]-yy[2];
		e5[2]=zz[3]-zz[2];

		el5=vec_length(e5);

		e6[0]=xx[2]-xx[1];
		e6[1]=yy[2]-yy[1];
		e6[2]=zz[2]-zz[1];

		el6=vec_length(e6);

		//cout << el1 << " " << el2 << " " << el3 << " " << el4 << " " << el5 << " " << el6 << endl;

		in_hexa = false;

		if( (el1==dis) && (r[0]!=r[3]) && (r[0] != -1) && (r[3] != -1) ){
			hexa_size=hexa_size+1;
		}
		if( (el2==dis) && (r[0]!=r[2]) && (r[0] != -1) && (r[2] != -1) ){
			hexa_size=hexa_size+1;
		}
		if( (el3==dis) && (r[0]!=r[1]) && (r[0] != -1) && (r[1] != -1) ){
			hexa_size=hexa_size+1;
		}
		if( (el4==dis) && (r[1]!=r[3]) && (r[1] != -1) && (r[3] != -1) ){
			hexa_size=hexa_size+1;
		}
		if( (el5==dis) && (r[2]!=r[3]) && (r[2] != -1) && (r[3] != -1) ){
			hexa_size=hexa_size+1;
		}
		if( (el6==dis) && (r[1]!=r[2]) && (r[1] != -1) && (r[2] != -1) ){
			hexa_size=hexa_size+1;
		}

		//region_input = max( max( max(r[0],r[1]), r[2]), r[3]) ;
		//tet_class_array_red5[q].set_region(region_input);
	};
	}


}

cout << "hexa_size is "<< hexa_size << endl;
hexa_size=hexa_size/4;
cout << "hexa_size is "<< hexa_size << endl;

hexa *hexa_class_array; hexa_class_array = new hexa[hexa_size];


/////////////////////////////////////////////////////////////////
//fillig in hexa values

pre_initialize_hexa(hexa_class_array, node_class_array, hexa_size, node_class_array_size);
long m = 0;
long current_hexa;

cout << "hexa preinitialized" << endl;


if(param.use_lite == false){

for(long q=0; q<tet_class_array_red_size; q++){
	if(tet_class_array_red[q].removed == false){

		//tet_class_array_red[q].hexad = false;

		pp[0] = *tet_class_array_red[q].node1;
		pp[1] = *tet_class_array_red[q].node2;
		pp[2] = *tet_class_array_red[q].node3;
		pp[3] = *tet_class_array_red[q].node4;

		for (long u=0; u<4; u++){

			xx[u] = *node_class_array[pp[u]].x;
			yy[u] = *node_class_array[pp[u]].y;
			zz[u] = *node_class_array[pp[u]].z;

		};

		for (long u=0;u<4;u++){
			r[u] = region(xx[u], yy[u], zz[u], regions_array, param, zoom_level);
		}

		e1[0]=xx[3]-xx[0];
		e1[1]=yy[3]-yy[0];
		e1[2]=zz[3]-zz[0];

		el1=vec_length(e1);

		e2[0]=xx[2]-xx[0];
		e2[1]=yy[2]-yy[0];
		e2[2]=zz[2]-zz[0];

		el2=vec_length(e2);

		e3[0]=xx[1]-xx[0];
		e3[1]=yy[1]-yy[0];
		e3[2]=zz[1]-zz[0];

		el3=vec_length(e3);

		e4[0]=xx[3]-xx[1];
		e4[1]=yy[3]-yy[1];
		e4[2]=zz[3]-zz[1];

		el4=vec_length(e4);

		e5[0]=xx[3]-xx[2];
		e5[1]=yy[3]-yy[2];
		e5[2]=zz[3]-zz[2];

		el5=vec_length(e5);

		e6[0]=xx[2]-xx[1];
		e6[1]=yy[2]-yy[1];
		e6[2]=zz[2]-zz[1];

		el6=vec_length(e6);

		//cout << el1 << " " << el2 << " " << el3 << " " << el4 << " " << el5 << " " << el6 << endl;

		//cout << q<< " " << *tet_class_array_red5[q].tet_number << endl;

		//cout << r[0] << " " << r[1] << " " << r[2] << " " << r[3] << " " << endl;

		if( (el1==dis) && (r[0]!=r[3]) && (r[0] != -1) && (r[3] != -1) ){
			current_hexa = hex_entered(pp[0], pp[3], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[0]].add_hexa(m);
				node_class_array[pp[3]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[0], pp[3], pp[1], pp[2], r[0], r[3], r[1], r[2]);
			//node_class_array6[pp[1]].other_number_of_hexa_belong = node_class_array6[pp[1]].other_number_of_hexa_belong+1;
			//node_class_array6[pp[2]].other_number_of_hexa_belong = node_class_array6[pp[2]].other_number_of_hexa_belong+1;
		}
		if( (el2==dis) && (r[0]!=r[2]) && (r[0] != -1) && (r[2] != -1) ){
			current_hexa = hex_entered(pp[0], pp[2], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[0]].add_hexa(m);
				node_class_array[pp[2]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[0], pp[2], pp[1], pp[3], r[0], r[2], r[1], r[3]);
			//node_class_array6[pp[1]].other_number_of_hexa_belong = node_class_array6[pp[1]].other_number_of_hexa_belong+1;
			//node_class_array6[pp[3]].other_number_of_hexa_belong = node_class_array6[pp[3]].other_number_of_hexa_belong+1;
		}
		if( (el3==dis) && (r[0]!=r[1]) && (r[0] != -1) && (r[1] != -1) ){
			current_hexa = hex_entered(pp[0], pp[1], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[0]].add_hexa(m);
				node_class_array[pp[1]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[0], pp[1], pp[2], pp[3], r[0], r[1], r[2], r[3]);
		}
		if( (el4==dis) && (r[1]!=r[3]) && (r[1] != -1) && (r[3] != -1) ){
			current_hexa = hex_entered(pp[1], pp[3], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[1]].add_hexa(m);
				node_class_array[pp[3]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[1], pp[3], pp[0], pp[2], r[1], r[3], r[0], r[2]);
			//node_class_array6[pp[2]].other_number_of_hexa_belong = node_class_array6[pp[2]].other_number_of_hexa_belong+1;
			//node_class_array6[pp[3]].other_number_of_hexa_belong = node_class_array6[pp[3]].other_number_of_hexa_belong+1;
		}
		if( (el5==dis) && (r[2]!=r[3]) && (r[2] != -1) && (r[3] != -1) ){
			current_hexa = hex_entered(pp[2], pp[3], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[2]].add_hexa(m);
				node_class_array[pp[3]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[2], pp[3], pp[0], pp[1], r[2], r[3], r[0], r[1]);
			//node_class_array6[pp[0]].other_number_of_hexa_belong = node_class_array6[pp[0]].other_number_of_hexa_belong+1;
			//node_class_array6[pp[1]].other_number_of_hexa_belong = node_class_array6[pp[1]].other_number_of_hexa_belong+1;
		}
		if( (el6==dis) && (r[1]!=r[2]) && (r[1] != -1) && (r[2] != -1) ){
			current_hexa = hex_entered(pp[1], pp[2], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[1]].add_hexa(m);
				node_class_array[pp[2]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[1], pp[2], pp[0], pp[3], r[1], r[2], r[0], r[3]);
			//node_class_array6[pp[0]].other_number_of_hexa_belong = node_class_array6[pp[0]].other_number_of_hexa_belong+1;
			//node_class_array6[pp[3]].other_number_of_hexa_belong = node_class_array6[pp[3]].other_number_of_hexa_belong+1;
		}

		//region_input = max( max( max(r[0],r[1]), r[2]), r[3]) ;
		//tet_class_array_red5[q].set_region(region_input);
	};
};



}else{

	for(long q=0; q<tet_class_array_red_size; q++){
		if(param.tet_class_array_red5[q].removed == false){

		//tet_class_array_red[q].hexad = false;

		pp[0] = *param.tet_class_array_red5[q].node1;
		pp[1] = *param.tet_class_array_red5[q].node2;
		pp[2] = *param.tet_class_array_red5[q].node3;
		pp[3] = *param.tet_class_array_red5[q].node4;

		for (long u=0; u<4; u++){

			xx[u] = *node_class_array[pp[u]].x;
			yy[u] = *node_class_array[pp[u]].y;
			zz[u] = *node_class_array[pp[u]].z;

		};

		for (long u=0;u<4;u++){
			r[u] = region(xx[u], yy[u], zz[u], regions_array, param, zoom_level);
		}

		e1[0]=xx[3]-xx[0];
		e1[1]=yy[3]-yy[0];
		e1[2]=zz[3]-zz[0];

		el1=vec_length(e1);

		e2[0]=xx[2]-xx[0];
		e2[1]=yy[2]-yy[0];
		e2[2]=zz[2]-zz[0];

		el2=vec_length(e2);

		e3[0]=xx[1]-xx[0];
		e3[1]=yy[1]-yy[0];
		e3[2]=zz[1]-zz[0];

		el3=vec_length(e3);

		e4[0]=xx[3]-xx[1];
		e4[1]=yy[3]-yy[1];
		e4[2]=zz[3]-zz[1];

		el4=vec_length(e4);

		e5[0]=xx[3]-xx[2];
		e5[1]=yy[3]-yy[2];
		e5[2]=zz[3]-zz[2];

		el5=vec_length(e5);

		e6[0]=xx[2]-xx[1];
		e6[1]=yy[2]-yy[1];
		e6[2]=zz[2]-zz[1];

		el6=vec_length(e6);

		//cout << el1 << " " << el2 << " " << el3 << " " << el4 << " " << el5 << " " << el6 << endl;

		//cout << q<< " " << *tet_class_array_red5[q].tet_number << endl;

		//cout << r[0] << " " << r[1] << " " << r[2] << " " << r[3] << " " << endl;

		if( (el1==dis) && (r[0]!=r[3]) && (r[0] != -1) && (r[3] != -1) ){
			current_hexa = hex_entered(pp[0], pp[3], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[0]].add_hexa(m);
				node_class_array[pp[3]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[0], pp[3], pp[1], pp[2], r[0], r[3], r[1], r[2]);
			//node_class_array6[pp[1]].other_number_of_hexa_belong = node_class_array6[pp[1]].other_number_of_hexa_belong+1;
			//node_class_array6[pp[2]].other_number_of_hexa_belong = node_class_array6[pp[2]].other_number_of_hexa_belong+1;
		}
		if( (el2==dis) && (r[0]!=r[2]) && (r[0] != -1) && (r[2] != -1) ){
			current_hexa = hex_entered(pp[0], pp[2], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[0]].add_hexa(m);
				node_class_array[pp[2]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[0], pp[2], pp[1], pp[3], r[0], r[2], r[1], r[3]);
			//node_class_array6[pp[1]].other_number_of_hexa_belong = node_class_array6[pp[1]].other_number_of_hexa_belong+1;
			//node_class_array6[pp[3]].other_number_of_hexa_belong = node_class_array6[pp[3]].other_number_of_hexa_belong+1;
		}
		if( (el3==dis) && (r[0]!=r[1]) && (r[0] != -1) && (r[1] != -1) ){
			current_hexa = hex_entered(pp[0], pp[1], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[0]].add_hexa(m);
				node_class_array[pp[1]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[0], pp[1], pp[2], pp[3], r[0], r[1], r[2], r[3]);
		}
		if( (el4==dis) && (r[1]!=r[3]) && (r[1] != -1) && (r[3] != -1) ){
			current_hexa = hex_entered(pp[1], pp[3], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[1]].add_hexa(m);
				node_class_array[pp[3]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[1], pp[3], pp[0], pp[2], r[1], r[3], r[0], r[2]);
			//node_class_array6[pp[2]].other_number_of_hexa_belong = node_class_array6[pp[2]].other_number_of_hexa_belong+1;
			//node_class_array6[pp[3]].other_number_of_hexa_belong = node_class_array6[pp[3]].other_number_of_hexa_belong+1;
		}
		if( (el5==dis) && (r[2]!=r[3]) && (r[2] != -1) && (r[3] != -1) ){
			current_hexa = hex_entered(pp[2], pp[3], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[2]].add_hexa(m);
				node_class_array[pp[3]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[2], pp[3], pp[0], pp[1], r[2], r[3], r[0], r[1]);
			//node_class_array6[pp[0]].other_number_of_hexa_belong = node_class_array6[pp[0]].other_number_of_hexa_belong+1;
			//node_class_array6[pp[1]].other_number_of_hexa_belong = node_class_array6[pp[1]].other_number_of_hexa_belong+1;
		}
		if( (el6==dis) && (r[1]!=r[2]) && (r[1] != -1) && (r[2] != -1) ){
			current_hexa = hex_entered(pp[1], pp[2], node_class_array);
			if( current_hexa == -1 ){
				node_class_array[pp[1]].add_hexa(m);
				node_class_array[pp[2]].add_hexa(m);
				current_hexa = m;
				m=m+1;
			}
			hexa_class_array[current_hexa].add_tet(q, pp[1], pp[2], pp[0], pp[3], r[1], r[2], r[0], r[3]);
			//node_class_array6[pp[0]].other_number_of_hexa_belong = node_class_array6[pp[0]].other_number_of_hexa_belong+1;
			//node_class_array6[pp[3]].other_number_of_hexa_belong = node_class_array6[pp[3]].other_number_of_hexa_belong+1;
		}

		//region_input = max( max( max(r[0],r[1]), r[2]), r[3]) ;
		//tet_class_array_red5[q].set_region(region_input);
	};
	}



	}

//for(long q=0; q<hexa_size; q++){
//	if(hexa_class_array[q].removed == false){

		//cout << q << " " <<hexa_class_array[q].main_node[0] << " " << hexa_class_array[q].tet1 << " "<< hexa_class_array[q].diag << " " << hexa_class_array[q].t1[0] << endl;

//	}
//}


//////////////////////////////////////////////
//remaking tets

long *cand_p1;
long *cand_p2;

short counter;
short cand_pt_num;

bool use_03;
bool use_12;
bool use_02;
bool use_13;

if(param.use_lite == false){


for(long q=0; q<hexa_size; q++){
	if(hexa_class_array[q].removed == false){


		counter = 0;
		cand_pt_num = 0;

		pp[0] = hexa_class_array[q].other_node[0];
		pp[1] = hexa_class_array[q].other_node[1];
		pp[2] = hexa_class_array[q].other_node[2];
		pp[3] = hexa_class_array[q].other_node[3];


		for(short m=0;m<4;m++){
			for(short b=0;b<8;b++){
				if(node_class_array[pp[m]].diag_bdry_share[b] != -1){
					cand_pt_num = cand_pt_num + 1;
				}
			}
		}



		cand_p1 = new long[cand_pt_num];
		cand_p2 = new long[cand_pt_num];



		for(short m=0;m<4;m++){
			for(short b=0;b<8;b++){
				if(node_class_array[pp[m]].diag_bdry_share[b] != -1){
					cand_p1[counter] = pp[m];
					cand_p2[counter]=node_class_array[pp[m]].diag_bdry_share[b];
					counter = counter + 1;
				}
			}
		}

		//cout << counter << endl;

		use_03 = false;
		use_12 = false;
		use_02 = false;
		use_13 = false;

		if( (hexa_class_array[q].diag == 03) || (hexa_class_array[q].diag == 12) ){

			for(short m=0;m<cand_pt_num;m++){

				if( (cand_p1[m] == hexa_class_array[q].other_node[0]) || (cand_p2[m] == hexa_class_array[q].other_node[0]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[3]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[3]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[3]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_03 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[3]) || (cand_p2[m] == hexa_class_array[q].other_node[3]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[0]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[0]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[0]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_03 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[1]) || (cand_p2[m] == hexa_class_array[q].other_node[1]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[2]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[2]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[2]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_12 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[2]) || (cand_p2[m] == hexa_class_array[q].other_node[2]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[1]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[1]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[1]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_12 = true;

					}

				}

			}

		}

		//

		if( (hexa_class_array[q].diag == 13) || (hexa_class_array[q].diag == 02) ){

			for(short m=0;m<cand_pt_num;m++){

				if( (cand_p1[m] == hexa_class_array[q].other_node[0]) || (cand_p2[m] == hexa_class_array[q].other_node[0]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[2]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[2]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[2]].z;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_02 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[2]) || (cand_p2[m] == hexa_class_array[q].other_node[2]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[0]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[0]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[0]].z;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_02 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[1]) || (cand_p2[m] == hexa_class_array[q].other_node[1]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[3]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[3]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[3]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_13 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[3]) || (cand_p2[m] == hexa_class_array[q].other_node[3]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[1]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[1]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[1]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_13 = true;

					}

				}

			}

		}




		/*
		if(use_02 == true){
			//cout << "02" << endl;
		}
		if(use_12 == true){
			cout << "12" << endl;
		}
		if(use_03 == true){
			cout << "03" << endl;
		}
		if(use_13 == true){
			cout << "13" << endl;
		}
		*/

		//cout << hexa_class_array[q].diag << endl;



		hexa_class_array[q].remake_4_tets(use_02, use_03, use_12, use_13);

		tet_class_array_red[hexa_class_array[q].tet1].node1 = node_class_array[hexa_class_array[q].t1[0]].node_number;
		tet_class_array_red[hexa_class_array[q].tet1].node2 = node_class_array[hexa_class_array[q].t1[1]].node_number;
		tet_class_array_red[hexa_class_array[q].tet1].node3 = node_class_array[hexa_class_array[q].t1[2]].node_number;
		tet_class_array_red[hexa_class_array[q].tet1].node4 = node_class_array[hexa_class_array[q].t1[3]].node_number;
		tet_class_array_red[hexa_class_array[q].tet1].region = hexa_class_array[q].r1;
		//tet_class_array_red[hexa_class_array[q].tet1].hexad = true;

		tet_class_array_red[hexa_class_array[q].tet2].node1 = node_class_array[hexa_class_array[q].t2[0]].node_number;
		tet_class_array_red[hexa_class_array[q].tet2].node2 = node_class_array[hexa_class_array[q].t2[1]].node_number;
		tet_class_array_red[hexa_class_array[q].tet2].node3 = node_class_array[hexa_class_array[q].t2[2]].node_number;
		tet_class_array_red[hexa_class_array[q].tet2].node4 = node_class_array[hexa_class_array[q].t2[3]].node_number;
		tet_class_array_red[hexa_class_array[q].tet2].region = hexa_class_array[q].r2;
		//tet_class_array_red[hexa_class_array[q].tet2].hexad = true;

		tet_class_array_red[hexa_class_array[q].tet3].node1 = node_class_array[hexa_class_array[q].t3[0]].node_number;
		tet_class_array_red[hexa_class_array[q].tet3].node2 = node_class_array[hexa_class_array[q].t3[1]].node_number;
		tet_class_array_red[hexa_class_array[q].tet3].node3 = node_class_array[hexa_class_array[q].t3[2]].node_number;
		tet_class_array_red[hexa_class_array[q].tet3].node4 = node_class_array[hexa_class_array[q].t3[3]].node_number;
		tet_class_array_red[hexa_class_array[q].tet3].region = hexa_class_array[q].r3;
		//tet_class_array_red[hexa_class_array[q].tet3].hexad = true;

		tet_class_array_red[hexa_class_array[q].tet4].node1 = node_class_array[hexa_class_array[q].t4[0]].node_number;
		tet_class_array_red[hexa_class_array[q].tet4].node2 = node_class_array[hexa_class_array[q].t4[1]].node_number;
		tet_class_array_red[hexa_class_array[q].tet4].node3 = node_class_array[hexa_class_array[q].t4[2]].node_number;
		tet_class_array_red[hexa_class_array[q].tet4].node4 = node_class_array[hexa_class_array[q].t4[3]].node_number;
		tet_class_array_red[hexa_class_array[q].tet4].region = hexa_class_array[q].r4;
		//tet_class_array_red[hexa_class_array[q].tet4].hexad = true;

		delete [] cand_p1;
		delete [] cand_p2;

	}
}

}else{

	for(long q=0; q<hexa_size; q++){
	if(hexa_class_array[q].removed == false){


		counter = 0;
		cand_pt_num = 0;

		pp[0] = hexa_class_array[q].other_node[0];
		pp[1] = hexa_class_array[q].other_node[1];
		pp[2] = hexa_class_array[q].other_node[2];
		pp[3] = hexa_class_array[q].other_node[3];


		for(short m=0;m<4;m++){
			for(short b=0;b<8;b++){
				if(node_class_array[pp[m]].diag_bdry_share[b] != -1){
					cand_pt_num = cand_pt_num + 1;
				}
			}
		}



		cand_p1 = new long[cand_pt_num];
		cand_p2 = new long[cand_pt_num];



		for(short m=0;m<4;m++){
			for(short b=0;b<8;b++){
				if(node_class_array[pp[m]].diag_bdry_share[b] != -1){
					cand_p1[counter] = pp[m];
					cand_p2[counter]=node_class_array[pp[m]].diag_bdry_share[b];
					counter = counter + 1;
				}
			}
		}

		//cout << counter << endl;

		use_03 = false;
		use_12 = false;
		use_02 = false;
		use_13 = false;

		if( (hexa_class_array[q].diag == 03) || (hexa_class_array[q].diag == 12) ){

			for(short m=0;m<cand_pt_num;m++){

				if( (cand_p1[m] == hexa_class_array[q].other_node[0]) || (cand_p2[m] == hexa_class_array[q].other_node[0]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[3]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[3]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[3]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_03 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[3]) || (cand_p2[m] == hexa_class_array[q].other_node[3]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[0]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[0]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[0]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_03 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[1]) || (cand_p2[m] == hexa_class_array[q].other_node[1]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[2]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[2]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[2]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_12 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[2]) || (cand_p2[m] == hexa_class_array[q].other_node[2]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[1]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[1]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[1]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_12 = true;

					}

				}

			}

		}

		//

		if( (hexa_class_array[q].diag == 13) || (hexa_class_array[q].diag == 02) ){

			for(short m=0;m<cand_pt_num;m++){

				if( (cand_p1[m] == hexa_class_array[q].other_node[0]) || (cand_p2[m] == hexa_class_array[q].other_node[0]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[2]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[2]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[2]].z;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_02 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[2]) || (cand_p2[m] == hexa_class_array[q].other_node[2]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[0]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[0]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[0]].z;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_02 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[1]) || (cand_p2[m] == hexa_class_array[q].other_node[1]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[3]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[3]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[3]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_13 = true;

					}

				}

				if( (cand_p1[m] == hexa_class_array[q].other_node[3]) || (cand_p2[m] == hexa_class_array[q].other_node[3]) ){

					xx[0] = *node_class_array[cand_p1[m]].x;
					yy[0] = *node_class_array[cand_p1[m]].y;
					zz[0] = *node_class_array[cand_p1[m]].z;

					xx[1] = *node_class_array[cand_p2[m]].x;
					yy[1] = *node_class_array[cand_p2[m]].y;
					zz[1] = *node_class_array[cand_p2[m]].z;

					xx[2]=(xx[0]+xx[1])/2.0;
					yy[2]=(yy[0]+yy[1])/2.0;
					zz[2]=(zz[0]+zz[1])/2.0;

					xx[3] = *node_class_array[hexa_class_array[q].other_node[1]].x;
					yy[3] = *node_class_array[hexa_class_array[q].other_node[1]].y;
					zz[3] = *node_class_array[hexa_class_array[q].other_node[1]].z;

					//cout << xx[2] << " " << yy[2] << " " << zz[2] << endl;
					//cout << xx[3] << " " << yy[3] << " " << zz[3] << endl;
					//cout << " " << endl;

					if( (xx[2] == xx[3]) && (yy[2] == yy[3]) && (zz[2] == zz[3]) ){

						use_13 = true;

					}

				}

			}

		}




		/*
		if(use_02 == true){
			//cout << "02" << endl;
		}
		if(use_12 == true){
			cout << "12" << endl;
		}
		if(use_03 == true){
			cout << "03" << endl;
		}
		if(use_13 == true){
			cout << "13" << endl;
		}
		*/

		//cout << hexa_class_array[q].diag << endl;



		hexa_class_array[q].remake_4_tets(use_02, use_03, use_12, use_13);

		//tet_class_array_red[hexa_class_array[q].tet1].node1 = node_class_array[hexa_class_array[q].t1[0]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet1].node2 = node_class_array[hexa_class_array[q].t1[1]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet1].node3 = node_class_array[hexa_class_array[q].t1[2]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet1].node4 = node_class_array[hexa_class_array[q].t1[3]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet1].region = hexa_class_array[q].r1;

		param.tet_class_array_red5[hexa_class_array[q].tet1].node1 = node_class_array[hexa_class_array[q].t1[0]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet1].node2 = node_class_array[hexa_class_array[q].t1[1]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet1].node3 = node_class_array[hexa_class_array[q].t1[2]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet1].node4 = node_class_array[hexa_class_array[q].t1[3]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet1].region = hexa_class_array[q].r1;
		//tet_class_array_red[hexa_class_array[q].tet1].hexad = true;

		//tet_class_array_red[hexa_class_array[q].tet2].node1 = node_class_array[hexa_class_array[q].t2[0]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet2].node2 = node_class_array[hexa_class_array[q].t2[1]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet2].node3 = node_class_array[hexa_class_array[q].t2[2]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet2].node4 = node_class_array[hexa_class_array[q].t2[3]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet2].region = hexa_class_array[q].r2;
		//tet_class_array_red[hexa_class_array[q].tet2].hexad = true;

		param.tet_class_array_red5[hexa_class_array[q].tet2].node1 = node_class_array[hexa_class_array[q].t2[0]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet2].node2 = node_class_array[hexa_class_array[q].t2[1]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet2].node3 = node_class_array[hexa_class_array[q].t2[2]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet2].node4 = node_class_array[hexa_class_array[q].t2[3]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet2].region = hexa_class_array[q].r2;

		//tet_class_array_red[hexa_class_array[q].tet3].node1 = node_class_array[hexa_class_array[q].t3[0]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet3].node2 = node_class_array[hexa_class_array[q].t3[1]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet3].node3 = node_class_array[hexa_class_array[q].t3[2]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet3].node4 = node_class_array[hexa_class_array[q].t3[3]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet3].region = hexa_class_array[q].r3;
		//tet_class_array_red[hexa_class_array[q].tet3].hexad = true;

		param.tet_class_array_red5[hexa_class_array[q].tet3].node1 = node_class_array[hexa_class_array[q].t3[0]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet3].node2 = node_class_array[hexa_class_array[q].t3[1]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet3].node3 = node_class_array[hexa_class_array[q].t3[2]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet3].node4 = node_class_array[hexa_class_array[q].t3[3]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet3].region = hexa_class_array[q].r3;


		//tet_class_array_red[hexa_class_array[q].tet4].node1 = node_class_array[hexa_class_array[q].t4[0]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet4].node2 = node_class_array[hexa_class_array[q].t4[1]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet4].node3 = node_class_array[hexa_class_array[q].t4[2]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet4].node4 = node_class_array[hexa_class_array[q].t4[3]].node_number;
		//tet_class_array_red[hexa_class_array[q].tet4].region = hexa_class_array[q].r4;
		//tet_class_array_red[hexa_class_array[q].tet4].hexad = true;

		param.tet_class_array_red5[hexa_class_array[q].tet4].node1 = node_class_array[hexa_class_array[q].t4[0]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet4].node2 = node_class_array[hexa_class_array[q].t4[1]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet4].node3 = node_class_array[hexa_class_array[q].t4[2]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet4].node4 = node_class_array[hexa_class_array[q].t4[3]].node_number;
		param.tet_class_array_red5[hexa_class_array[q].tet4].region = hexa_class_array[q].r4;

		delete [] cand_p1;
		delete [] cand_p2;

	}

}



	}


for(long n=0;n<node_class_array_size;n++){
	for(short m=0;m<8;m++){
		node_class_array[n].diag_bdry_share[m] = -1;
	}
}

bool stop;

for(long n=0;n<hexa_size;n++){

	pp[0] = hexa_class_array[n].diag_node_1;
	pp[1] = hexa_class_array[n].diag_node_2;

	//cout << pp[0] << " " << pp[1] << endl;

	stop = false;
	for(short m=0;m<8;m++){
		
		if( (node_class_array[pp[0]].diag_bdry_share[m] == -1) && (stop == false) ){

			node_class_array[pp[0]].diag_bdry_share[m] = pp[1];
			stop = true;

		}
	}

}

delete [] hexa_class_array;



}






void output(tet tet_class_array[], long tet_class_array_size, tet tet_class_array_red[], long tet_class_array_red_size, tet tet_class_array_green[], long tet_class_array_green_size, node node_class_array[], long node_class_array_size,parameters &param, char node_file[], char ele_file[]){


ofstream out_stream;

out_stream.open(ele_file);
//matlab out_stream.open("tets.m");

//the code below will make a tet without refering to edges

long color_print;

long p[4];
float xp;
float yp;
float zp;

long ww = 0;

for(long q=0; q<tet_class_array_size; q++){
	if(tet_class_array[q].removed == false){

		p[0] = *tet_class_array[q].node1;
		p[1] = *tet_class_array[q].node2;
		p[2] = *tet_class_array[q].node3;
		p[3] = *tet_class_array[q].node4;

ww = ww+1;

		
	};
};

if(param.use_lite == false){

for(long q=0; q<tet_class_array_red_size; q++){
	if(tet_class_array_red[q].removed == false){

		p[0] = *tet_class_array_red[q].node1;
		p[1] = *tet_class_array_red[q].node2;
		p[2] = *tet_class_array_red[q].node3;
		p[3] = *tet_class_array_red[q].node4;

ww = ww+1;

		
	};
};

}else{

	for(long q=0; q<tet_class_array_red_size; q++){
		if(param.tet_class_array_red5[q].removed == false){

		p[0] = *param.tet_class_array_red5[q].node1;
		p[1] = *param.tet_class_array_red5[q].node2;
		p[2] = *param.tet_class_array_red5[q].node3;
		p[3] = *param.tet_class_array_red5[q].node4;

ww = ww+1;

		}
	};
};




if(param.use_lite == false){


for(long q=0; q<tet_class_array_green_size; q++){
	if(tet_class_array_green[q].removed == false){

		p[0] = *tet_class_array_green[q].node1;
		p[1] = *tet_class_array_green[q].node2;
		p[2] = *tet_class_array_green[q].node3;
		p[3] = *tet_class_array_green[q].node4;

ww = ww+1;

		
	};
};

}else{


	for(long q=0; q<tet_class_array_green_size; q++){
		if(param.tet_class_array_green5[q].removed == false){

		p[0] = *param.tet_class_array_green5[q].node1;
		p[1] = *param.tet_class_array_green5[q].node2;
		p[2] = *param.tet_class_array_green5[q].node3;
		p[3] = *param.tet_class_array_green5[q].node4;

ww = ww+1;

		};
	};


}



out_stream << ww << " " << 4 << " " << 1 << endl;
//matlab out_stream << "T=zeros("  << ww << "," << 4 <<  ");" << endl;

ww=1;


for(long q=0; q<tet_class_array_size; q++){
	if(tet_class_array[q].removed == false){


		color_print = tet_class_array[q].region;

p[0] = *tet_class_array[q].node1 ;
p[1] = *tet_class_array[q].node2 ;
p[2] = *tet_class_array[q].node3 ;
p[3] = *tet_class_array[q].node4 ;
	

 out_stream << " "<< ww << " " << p[0] << " " << p[1] <<" " << p[2] << " "  << p[3] << " " << color_print << endl;
//matlab out_stream << "T("<< ww << ",1)=" << p[0] << ";" << endl ;   
//matlab out_stream << "T("<< ww << ",2)=" << p[1] << ";" << endl ;
//matlab out_stream << "T("<< ww << ",3)=" << p[2] << ";" << endl ;
//matlab out_stream << "T("<< ww << ",4)=" << p[3] << ";" << endl ;

ww = ww+1;

		//};
	};
};

if(param.use_lite == false){

for(long q=0; q<tet_class_array_red_size; q++){
	if(tet_class_array_red[q].removed == false){


		color_print = tet_class_array_red[q].region;


p[0] = *tet_class_array_red[q].node1 ;
p[1] = *tet_class_array_red[q].node2 ;
p[2] = *tet_class_array_red[q].node3 ;
p[3] = *tet_class_array_red[q].node4 ;
	

 out_stream << " "<< ww << " " << p[0] << " " << p[1] <<" " << p[2] << " "  << p[3] << " " << color_print << endl;
//matlab out_stream << "T("<< ww << ",1)=" << p[0] << ";" << endl ;   
//matlab out_stream << "T("<< ww << ",2)=" << p[1] << ";" << endl ;
//matlab out_stream << "T("<< ww << ",3)=" << p[2] << ";" << endl ;
//matlab out_stream << "T("<< ww << ",4)=" << p[3] << ";" << endl ;

ww = ww+1;

		//};
	};
};

for(long q=0; q<tet_class_array_green_size; q++){
	if(tet_class_array_green[q].removed == false){


		color_print = tet_class_array_green[q].region;


p[0] = *tet_class_array_green[q].node1 ;
p[1] = *tet_class_array_green[q].node2 ;
p[2] = *tet_class_array_green[q].node3 ;
p[3] = *tet_class_array_green[q].node4 ;
	

 out_stream << " "<< ww << " " << p[0] << " " << p[1] <<" " << p[2] << " "  << p[3] << " " << color_print << endl;
//matlab out_stream << "T("<< ww << ",1)=" << p[0] << ";" << endl ;   
//matlab out_stream << "T("<< ww << ",2)=" << p[1] << ";" << endl ;
//matlab out_stream << "T("<< ww << ",3)=" << p[2] << ";" << endl ;
//matlab out_stream << "T("<< ww << ",4)=" << p[3] << ";" << endl ;

ww = ww+1;

		//};
	};
};

}else{

	for(long q=0; q<tet_class_array_red_size; q++){
		if(param.tet_class_array_red5[q].removed == false){

		color_print = param.tet_class_array_red5[q].region;


p[0] = *param.tet_class_array_red5[q].node1 ;
p[1] = *param.tet_class_array_red5[q].node2 ;
p[2] = *param.tet_class_array_red5[q].node3 ;
p[3] = *param.tet_class_array_red5[q].node4 ;
	

 out_stream << " "<< ww << " " << p[0] << " " << p[1] <<" " << p[2] << " "  << p[3] << " " << color_print << endl;
//matlab out_stream << "T("<< ww << ",1)=" << p[0] << ";" << endl ;   
//matlab out_stream << "T("<< ww << ",2)=" << p[1] << ";" << endl ;
//matlab out_stream << "T("<< ww << ",3)=" << p[2] << ";" << endl ;
//matlab out_stream << "T("<< ww << ",4)=" << p[3] << ";" << endl ;

ww = ww+1;

		//};
		}
	};

for(long q=0; q<tet_class_array_green_size; q++){
	if(param.tet_class_array_green5[q].removed == false){



		color_print = param.tet_class_array_green5[q].region;


p[0] = *param.tet_class_array_green5[q].node1 ;
p[1] = *param.tet_class_array_green5[q].node2 ;
p[2] = *param.tet_class_array_green5[q].node3 ;
p[3] = *param.tet_class_array_green5[q].node4 ;
	

 out_stream << " "<< ww << " " << p[0] << " " << p[1] <<" " << p[2] << " "  << p[3] << " " << color_print << endl;
//matlab out_stream << "T("<< ww << ",1)=" << p[0] << ";" << endl ;   
//matlab out_stream << "T("<< ww << ",2)=" << p[1] << ";" << endl ;
//matlab out_stream << "T("<< ww << ",3)=" << p[2] << ";" << endl ;
//matlab out_stream << "T("<< ww << ",4)=" << p[3] << ";" << endl ;

ww = ww+1;

		//};
	}
};

};







 out_stream.close();


out_stream.open(node_file);

out_stream << (node_class_array_size - 1) << " " << 3 << endl;
//matlab out_stream << "X = zeros("<<(node_class_array4_size - 1) << ", " << 3 << "):" << endl;


for(long r=1; r<node_class_array_size; r++){

	xp = *node_class_array[r].x;
	yp = *node_class_array[r].y;
	zp = *node_class_array[r].z;

	out_stream << r << " " << xp << " " << yp << " " << zp << " " << endl;
	//matlab out_stream << "X(" << r  << ",1)=" << xp << ";" <<endl; 
	//matlab out_stream << "X(" << r  << ",2)=" << yp << ";" <<endl;
	//matlab out_stream << "X(" << r  << ",3)=" << zp << ";" <<endl;



};



cout << "printed" << endl;



}



//instead of printing the node locations, we define these nodes by two nodes that they lie between
//new_node_number old1 old2
//have new_node_number = (old1+old2)/2;

void output_tbd_nodes(long node_array_red_size, long node_array_size, edge edge_class_array[], long edge_class_array_size,parameters &param, char node_tbd_file[]){

	long p1;
	long p2;
	long pn;

	long m=0;

	ofstream out_stream;

	out_stream.open(node_tbd_file);

	out_stream << node_array_red_size << endl;

	for( long n=0; n < edge_class_array_size; n++){

		if(edge_class_array[n].edge_split == to_split1){

			p1 = *edge_class_array[n].node1;
			p2 = *edge_class_array[n].node2;

			pn = m + node_array_size;

			out_stream << pn << " " << p1 << " " << p2 << endl;

			m=m+1;

		}

	};

	 out_stream.close();

}

	 