#include "stdafx.h"



#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"


//void parameters::initialize_parameters(char *segmentation_text_file, char *level_set_file, int sx, int sy, int sz, int largest_grid_space, int number_of_refinements, char *output_ele1, char *output_node1, char *region_file_z21, char *ls_file_z21, char *region_file_z31, char *ls_file_z31, char *output_ele_file_z21, char *output_node_file_z21, char *output_ele_file_z31, char *output_node_file_z31, char *output_node_tbd_z11, char *output_node_tbd_z21, char *output_node_tbd_z31){
void parameters::initialize_parameters(char *region_file1, char *level_set_file1, char *node_file1, char *ele_file1, char *parameters_file1){


	long size_xi;
	long size_yi;
	long size_zi;
	float timestep_sizei;
	long timestep_numberi;
	float alphai;
	float betai;
	float Ci;
	float kappai;
	float k1i;
	float k2i;
	float k3i;
	float e1i;
	float e2i;
	float e3i;
	float ls_derivative_smoothingi;
	ifstream in_stream;
	in_stream.open(parameters_file1);

	in_stream >> size_xi ;
	in_stream >> size_yi ;
	in_stream >> size_zi ;
	in_stream >> timestep_sizei;
	in_stream >> timestep_numberi;
	in_stream >> alphai;
	in_stream >> betai;
	in_stream >> Ci;
	in_stream >> kappai;
	in_stream >> k1i;
	in_stream >> k2i;
	in_stream >> k3i;
	in_stream >> e1i;
	in_stream >> e2i;
	in_stream >> e3i;
	in_stream >> ls_derivative_smoothingi;
	in_stream.close();

	float	largest_grid_space = 32.0;
	long number_of_refinements = 5;


	strcpy(filename_region, region_file1); //"regions00.txt" );
	strcpy(filename_ls, level_set_file1);//"level_set00_v2.txt");
	strcpy(output_ele, ele_file1);
	strcpy(output_node, node_file1);

	//strcpy(region_file_z2, region_file_z21);
	//strcpy(ls_file_z2, ls_file_z21);
	//strcpy(region_file_z3, region_file_z31);
	//strcpy(ls_file_z3, ls_file_z31); 
	//strcpy(output_ele_file_z2, output_ele_file_z21);
	//strcpy(output_node_file_z2, output_node_file_z21); 
	//strcpy(output_ele_file_z3, output_ele_file_z31); 
	//strcpy(output_node_file_z3, output_node_file_z31); 
	//strcpy(output_node_tbd_z1, output_node_tbd_z11); 
	//strcpy(output_node_tbd_z2, output_node_tbd_z21);
	//strcpy(output_node_tbd_z3, output_node_tbd_z31);


	//**Enter the image size.  Gridspace specifies the level of detail for the largest tetrahedrah.
	

	long image_x_min = 0;	// front
	long image_x_max = size_xi;//256;		// back
	long image_y_min = 0;	// left
	long image_y_max = size_yi;//256;		// right
	long image_z_min = 0;	// bottom
	long image_z_max = size_zi;//160;		// top
	grid_space = float(largest_grid_space);//64;

	size1D_x = image_x_max - image_x_min;
	size1D_y = image_y_max - image_y_min;
	size1D_z = image_z_max - image_z_min;

	if( (size1D_x % 2) == 1 ){
		size1D_x = size1D_x + 1;
	}
	if( (size1D_x % 4) == 2 ){
		size1D_x = size1D_x + 2;
	}

	if( (size1D_y % 2) == 1 ){
		size1D_y = size1D_y + 1;
	}
	if( (size1D_y % 4) == 2 ){
		size1D_y = size1D_y + 2;
	}

	if( (size1D_z % 2) == 1 ){
		size1D_z = size1D_z + 1;
	}
	if( (size1D_z % 4) == 2 ){
		size1D_z = size1D_z + 2;
	}



	size3D = size1D_x*size1D_y*size1D_z;

	size1D_x_z2=size1D_x/2+16;
	size1D_y_z2=size1D_y/2+16;
	size1D_z_z2=size1D_z/2+16;
	size3D_z2 = size1D_x_z2*size1D_y_z2*size1D_z_z2;

	size1D_x_z3=size1D_x/4+16;
	size1D_y_z3=size1D_y/4+16;
	size1D_z_z3=size1D_z/4+16;
	size3D_z3 = size1D_x_z3*size1D_y_z3*size1D_z_z3;

	size1D_xl_z2=size1D_x_z2*2;
	size1D_yl_z2=size1D_y_z2*2;
	size1D_zl_z2=size1D_z_z2*2;
	size3Dl_z2 = size3D_z2*8;

	size1D_xl_z3=size1D_x_z3*2;
	size1D_yl_z3=size1D_y_z3*2;
	size1D_zl_z3=size1D_z_z3*2;
	size3Dl_z3 = size3D_z3*8;

	size1D_x=size1D_x+16;
	size1D_y=size1D_y+16;
	size1D_z=size1D_z+16;
	size3D = size1D_x*size1D_y*size1D_z;

	size1D_xl=size1D_x*2;
	size1D_yl=size1D_y*2;
	size1D_zl=size1D_z*2;
	size3Dl = size3D*8;


	//The BCC lattice will be made of two interconnecting grids, grid1 and grid2.
	//The gridspace is the smallest distance between two points in grid1.  (Also the
	//smallest distance between two points in grid2)

	//The grid must be in a box big enough to cover the object of interest.  


	x_min = float(image_x_min) - grid_space-8;	// front
	x_max = float(image_x_max) + grid_space+8;		// back
	y_min = float(image_y_min) - grid_space-8;	// left
	y_max = float(image_y_max) + grid_space+8;		// right
	z_min = float(image_z_min) - grid_space-8;	// bottom
	z_max = float(image_z_max) + grid_space+8;		// top



	//x_nodes is a count of the number of nodes in the x direction.  starting at 1

	x_nodes = long (1 + floor((x_max - x_min)/grid_space));


	y_nodes = long (1 + floor((y_max - y_min)/grid_space));


	z_nodes = long (1 + floor((z_max - z_min)/grid_space));

	// the total number of points in grid1 is: 

	nodes_grid1_number = x_nodes * y_nodes * z_nodes;

	//grid2 will have the same number of nodes as grid1.
	//Each node will be shifted by half a grid space in each direction

	nodes_grid2_number = nodes_grid1_number;

	initial_node_number = nodes_grid1_number + nodes_grid2_number;

	initial_tet_number = 12*(x_nodes)*(y_nodes)*(z_nodes);


	
	threshold[0] = grid_space/(2);
	threshold[1] = grid_space/(4);
	threshold[2] = grid_space/(8);
	threshold[3] = grid_space/(16);
	threshold[4] = grid_space/(32);

	smallest_grid_space = grid_space/32.0;




	//signed_dist_value_refine is the number of red refinements made based on the signed distance value (max 5)
	//signed_dist_integral_refine is the number of red refinements made baseed on the signed distance integral;

	signed_dist_value_refine = number_of_refinements;//5;


	/*
	signed_dist_integral_refine = 0;

	int_threshold = .3;
*/

};


