#include "stdafx.h"



#include "node.h"
#include "edge.h"
#include "tet.h"
#include "parameters.h"
#include "face.h"

float signed_dist(float x, float y, float z, float signed_dist_array[],parameters &param, short zoom_level);
//short region(float x, float y, float z,  short region_array[],parameters &param);
float loc_integral(float x, float y, float z, float signed_dist_array[],parameters &param);




///////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////
//this program does a red refinement.  when the point at the center of a tet meets a certain criteria (distance from the 
//object boundary to start) the tet will be red refined.  The six edges of the to be refined tet are split, and new edges through
//the faces, and one through the tet, are made.  the red refinement creates 8 new tets out of the old one.  



////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//the pre_red_refine function calculates the sizes of the new node, edge, and tet class arrays


void make_ls_list(node node_class_array[], float signed_dist_array[], float signed_dist_array2[], float signed_dist_array3[], long node_size, parameters param){

	float xx,yy,zz;
	float ls;

	float v1, v2, v3;

	for(long n=0; n<node_size; n++){

		xx = *node_class_array[n].x;
		yy = *node_class_array[n].y;
		zz = *node_class_array[n].z;

		ls = signed_dist(xx, yy, zz, signed_dist_array, param, 1);


		
		param.ls_list[n] = ls;

	}


}


void pre_red_refine(node node_class_array[], edge edge_class_array[], tet tet_class_array[], long tet_class_array_size, face face_class_array[], float signed_dist_array[], float signed_dist_array2[], float signed_dist_array3[],parameters &param, short level_input){


	//first, the tets to be red refined and the edges to be split are marked

	long e[6];
//	long f1;
//	long f2;
//	long f3;
//	long f4;
	//float x_center;
	//float y_center;
	//float z_center;
	//float center;
	long p[4];
	float x[4];
	float y[4];
	float z[4];
	float ls[4];
	float ls2[4];
	float ls3[4];
	float ls_int[4];

	bool refine;


	long tet_class_array_red_size = 0;
	long new_node_class_array_size = 0;

	for(long n=0; n<tet_class_array_size; n++){

		if( ((tet_class_array[n].tet_color == have_red1) || (tet_class_array[n].tet_color == no_color)) && tet_class_array[n].removed == false ){
			if(tet_class_array[n].level == level_input){


				p[0] = *tet_class_array[n].node1;
				p[1] = *tet_class_array[n].node2;
				p[2] = *tet_class_array[n].node3;
				p[3] = *tet_class_array[n].node4;

				for (long u=0; u<4; u++){

					x[u] = *node_class_array[p[u]].x;
					y[u] = *node_class_array[p[u]].y;
					z[u] = *node_class_array[p[u]].z;

				};

				/*
				//this code refines based on distance of the tet center to the boundary

				x_center = (x[0]+x[1]+x[2]+x[3])/4;
				y_center = (y[0]+y[1]+y[2]+y[3])/4;
				z_center = (z[0]+z[1]+z[2]+z[3])/4;

				center = signed_dist(x_center, y_center, z_center, signed_dist_array, param);

				if(abs(center) < abs(param.red1_threshold[level_input])){

				*/

				//**********************************************************************************8
				//************************************************************************************
				//	*********************************************************************************
				//this code refines based on the signed distance function

				refine = false;

				if(level_input < (param.signed_dist_value_refine) ){
					for(long u=0;u<4;u++){
						if(param.use_list == false){
							ls[u] = signed_dist(x[u], y[u], z[u], signed_dist_array, param, 1);
							ls2[u] = signed_dist(x[u], y[u], z[u], signed_dist_array2, param, 2);
							ls3[u] = signed_dist(x[u], y[u], z[u], signed_dist_array3, param, 3);
							if(level_input == 3){
								ls3[u] = ls2[u];
							}
						}else{
							ls[u] = param.ls_list[p[u]];
							ls2[u] = param.ls_list[p[u]];
							ls3[u] = param.ls_list[p[u]];
						}
					};
					if(  ( (ls[0] < param.threshold[level_input]) || (ls[1] < param.threshold[level_input]) || (ls[2] < param.threshold[level_input]) || (ls[3] < param.threshold[level_input])     )  ){  //&& ( ((ls[0] <= (2.0*param.threshold[level_input])) || (ls[0]==800) ) && ((ls[1] <= (2.0*param.threshold[level_input]))  || (ls[1]==800) ) && ((ls[2] <= (2.0*param.threshold[level_input])) || (ls[2]==800) ) && ((ls[3] <= (2.0*param.threshold[level_input])) || (ls[3]==800) )     )  ){
						refine = true;
					};
					
					//if(  ( (ls2[0] < param.threshold[level_input]) || (ls2[1] < param.threshold[level_input]) || (ls2[2] < param.threshold[level_input]) || (ls2[3] < param.threshold[level_input])     )  ){  //&& ( ((ls[0] <= (2.0*param.threshold[level_input])) || (ls[0]==800) ) && ((ls[1] <= (2.0*param.threshold[level_input]))  || (ls[1]==800) ) && ((ls[2] <= (2.0*param.threshold[level_input])) || (ls[2]==800) ) && ((ls[3] <= (2.0*param.threshold[level_input])) || (ls[3]==800) )     )  ){
					//	refine = true;
					//};
					//if(  ( (ls3[0] < param.threshold[level_input]) || (ls3[1] < param.threshold[level_input]) || (ls3[2] < param.threshold[level_input]) || (ls3[3] < param.threshold[level_input])     )  ){  //&& ( ((ls[0] <= (2.0*param.threshold[level_input])) || (ls[0]==800) ) && ((ls[1] <= (2.0*param.threshold[level_input]))  || (ls[1]==800) ) && ((ls[2] <= (2.0*param.threshold[level_input])) || (ls[2]==800) ) && ((ls[3] <= (2.0*param.threshold[level_input])) || (ls[3]==800) )     )  ){
					//	refine = true;
					//};
					
					if( (param.threshold[level_input] > param.size1D_x) || (param.threshold[level_input] > param.size1D_y) || (param.threshold[level_input] > param.size1D_z) ){
						refine = true;
					}
				};

				//refines based on average value of signed distance function over a small box

/*
				if( (level_input >= (param.signed_dist_value_refine-1)) && ( level_input < param.signed_dist_integral_refine + param.signed_dist_value_refine - 1) ){
					for(long u=0;u<4;u++){
						ls_int[u] = loc_integral(x[u], y[u], z[u], signed_dist_array, param);
					};
					if( (ls_int[0] < param.int_threshold) || (ls_int[1] < param.int_threshold) || (ls_int[2] < param.int_threshold) || (ls_int[3] < param.int_threshold) ){
						refine = true;
						cout << "int refine hit" << endl;
					};
				};

*/		
				if(refine == true){

					tet_class_array[n].set_tet_color (to_red1);

					for(long m=0; m<6; m++){

						e[m] =*tet_class_array[n].edge_contain[m];
						edge_class_array[e[m]].set_to_split1 ();

					};

				
					//f1 = *tet_class_array[n].face1;
					//face_class_array[f1].set_to_red1 ();
					//f2 = *tet_class_array[n].face2;
					//face_class_array[f2].set_to_red1 ();
					//f3 = *tet_class_array[n].face3;
					//face_class_array[f3].set_to_red1 ();
					//f4 = *tet_class_array[n].face4;
					//face_class_array[f4].set_to_red1 ();

				
				};

			};

		};

	};

}
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

void mark_green_edge_splits(tet tet_class_array[], long tet_class_array_size, edge edge_class_array[]){

	long e[6];

	for(long n=0; n<tet_class_array_size; n++){
		if( ( (tet_class_array[n].tet_color == to_red1) ||(tet_class_array[n].tet_color == to_green1a) ||(tet_class_array[n].tet_color == to_green1b) || (tet_class_array[n].tet_color == to_green1c) ) && (tet_class_array[n].removed == false)){

			for(long m=0; m<6; m++){
				e[m] =*tet_class_array[n].edge_contain[m];
				if(edge_class_array[e[m]].edge_split == no_split){
					edge_class_array[e[m]].set_to_split1 ();
				};
			};

		};
	};

}









	////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////
	//the number of tets to be counted and new nodes made are counted

long calc_tet_class_array_red_size(tet tet_class_array[], long tet_class_array_size){

	long tet_class_array_red_size = 0;

	for(long n=0; n<tet_class_array_size; n++){

		if( ( (tet_class_array[n].tet_color == to_red1) ||(tet_class_array[n].tet_color == to_green1a) ||(tet_class_array[n].tet_color == to_green1b) || (tet_class_array[n].tet_color == to_green1c) ) && (tet_class_array[n].removed == false)){


			tet_class_array_red_size = tet_class_array_red_size + 8;

		};

	};
	
	return tet_class_array_red_size;

}

long calc_new_node_class_array_size (edge edge_class_array[], long edge_class_array_size){

	long new_node_class_array_size = 0;

	for(long n=0; n<edge_class_array_size; n++){

		if(edge_class_array[n].edge_split == to_split1){

			new_node_class_array_size = new_node_class_array_size + 1;

		};						

	};

	return new_node_class_array_size;

}



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//the red refinement

void red_refine(node node_class_array[], node new_node_class_array[], long node_array_size, edge edge_class_array[], tet tet_class_array[], long new_tet_array[], long tet_class_array_size, tet new_tet_class_array[], short level_input, parameters &param){

		//o=old, n=new, p=node, e=edge, t=tet

long *p_o1;
long *p_o2;
long *p_o3;
long *p_o4;
long *p_n1;
long *p_n2;
long *p_n3;
long *p_n4;
long *p_n5;
long *p_n6;

long e_o[6];

long t_num = 0;  //counts the number down in the tet_class_array


long u=0;



	for (long n=0; n<tet_class_array_size; n++){
		
		if( ( (tet_class_array[n].tet_color == to_red1) ||(tet_class_array[n].tet_color == to_green1a) ||(tet_class_array[n].tet_color == to_green1b) || (tet_class_array[n].tet_color == to_green1c) ) && (tet_class_array[n].removed == false)){


			p_o1=tet_class_array[n].node1;
			p_o2=tet_class_array[n].node2;
			p_o3=tet_class_array[n].node3;
			p_o4=tet_class_array[n].node4;


///////////////////////////////////////////////////////////////////////////////////////////////////
//numbering the new nodes
//nodes numbering
		//old : new
		//1-2 : 1
		//1-3 : 2
		//1-4 : 3
		//2-3 : 4
		//2-4 : 5
		//3-4 : 6


			for(long m=0; m<6; m++){

				e_o[m] = *tet_class_array[n].edge_contain[m];

				if(edge_class_array[e_o[m]].node1 == p_o1){
					if(edge_class_array[e_o[m]].node2 == p_o2){
						p_n1 = edge_class_array[e_o[m]].split_node;
					};
					if(edge_class_array[e_o[m]].node2 == p_o3){
						p_n2 = edge_class_array[e_o[m]].split_node;
					};
					if(edge_class_array[e_o[m]].node2 == p_o4){
						p_n3 = edge_class_array[e_o[m]].split_node;
					};
				};

				if(edge_class_array[e_o[m]].node1 == p_o2){
					if(edge_class_array[e_o[m]].node2 == p_o1){
						p_n1 = edge_class_array[e_o[m]].split_node;
					};
					if(edge_class_array[e_o[m]].node2 == p_o3){
						p_n4 = edge_class_array[e_o[m]].split_node;
					};
					if(edge_class_array[e_o[m]].node2 == p_o4){
						p_n5 = edge_class_array[e_o[m]].split_node;
					};
				};

				if(edge_class_array[e_o[m]].node1 == p_o3){
					if(edge_class_array[e_o[m]].node2 == p_o1){
						p_n2 = edge_class_array[e_o[m]].split_node;
					};
					if(edge_class_array[e_o[m]].node2 == p_o2){
						p_n4 = edge_class_array[e_o[m]].split_node;
					};
					if(edge_class_array[e_o[m]].node2 == p_o4){
						p_n6 = edge_class_array[e_o[m]].split_node;
					};
				};

				if(edge_class_array[e_o[m]].node1 == p_o4){
					if(edge_class_array[e_o[m]].node2 == p_o1){
						p_n3 = edge_class_array[e_o[m]].split_node;
					};
					if(edge_class_array[e_o[m]].node2 == p_o2){
						p_n5 = edge_class_array[e_o[m]].split_node;
					};
					if(edge_class_array[e_o[m]].node2 == p_o3){
						p_n6 = edge_class_array[e_o[m]].split_node;
					};
				};
			};

	

		

		
		//nodes numbering
		//old : new
		//1-2 : 1
		//1-3 : 2
		//1-4 : 3
		//2-3 : 4
		//2-4 : 5
		//3-4 : 6

////////////////////////////////////////////////////////////////////////////////////////////////

			if(param.use_lite == false){

				new_tet_class_array[t_num].new_tet(p_o1, p_n1, p_n2, p_n3, t_num, new_tet_array, have_red1, level_input);
				new_tet_class_array[t_num + 1].new_tet(p_o2, p_n1, p_n4, p_n5, t_num+1, new_tet_array, have_red1, level_input);
				new_tet_class_array[t_num + 2].new_tet(p_o3, p_n2, p_n4, p_n6, t_num+2, new_tet_array, have_red1, level_input);
				new_tet_class_array[t_num + 3].new_tet(p_o4, p_n3, p_n5, p_n6, t_num+3, new_tet_array, have_red1, level_input);

			}else{

				param.tet_class_array_red5[t_num].new_tet_lite(p_o1,p_n1,p_n2,p_n3,t_num,new_tet_array);
				param.tet_class_array_red5[t_num+1].new_tet_lite(p_o2,p_n1,p_n4,p_n5,t_num+1,new_tet_array);
				param.tet_class_array_red5[t_num+2].new_tet_lite(p_o3,p_n2,p_n4,p_n6,t_num+2,new_tet_array);
				param.tet_class_array_red5[t_num+3].new_tet_lite(p_o4,p_n3,p_n5,p_n6,t_num+3,new_tet_array);

			}
	

		//tet numbering
		//tet : nodes : edges
		//1 : o1, n1, n2, n3 : 1,2,3,13,14,15
		//2 : o2, n1, n4, n5 : 4,5,6,16,17,18
		//3 : o3, n2, n4, n6 : 7,8,9,19,20,21
		//4 : o4, n3, n5, n6 : 10,11,12,22,23,24


////////////////////////////////////////////////////////////////////////////////////////////////////
//measuring 3 distances

float n1_n6_dist;
float n2_n5_dist;
float n3_n4_dist;

float x_dist;
float y_dist;
float z_dist;

float x1;
float x2;
float y1;
float y2;
float z1;
float z2;

if (*p_n1 >= node_array_size){
	x1 = *new_node_class_array[*p_n1 - node_array_size].x;
	y1 = *new_node_class_array[*p_n1 - node_array_size].y;
	z1 = *new_node_class_array[*p_n1 - node_array_size].z;
}
else{
	x1 = *node_class_array[*p_n1].x;
	y1 = *node_class_array[*p_n1].y;
	z1 = *node_class_array[*p_n1].z;
}

if (*p_n6 >= node_array_size){
	x2 = *new_node_class_array[*p_n6 - node_array_size].x;
	y2 = *new_node_class_array[*p_n6 - node_array_size].y;
	z2 = *new_node_class_array[*p_n6 - node_array_size].z;
}
else{
	x2 = *node_class_array[*p_n6].x;
	y2 = *node_class_array[*p_n6].y;
	z2 = *node_class_array[*p_n6].z;
}

x_dist = x1 - x2;
y_dist = y1 - y2;
z_dist = z1 - z2;
n1_n6_dist = x_dist*x_dist + y_dist*y_dist + z_dist*z_dist;

if (*p_n2 >= node_array_size){
	x1 = *new_node_class_array[*p_n2 - node_array_size].x;
	y1 = *new_node_class_array[*p_n2 - node_array_size].y;
	z1 = *new_node_class_array[*p_n2 - node_array_size].z;
}
else{
	x1 = *node_class_array[*p_n2].x;
	y1 = *node_class_array[*p_n2].y;
	z1 = *node_class_array[*p_n2].z;
}

if (*p_n5 >= node_array_size){
	x2 = *new_node_class_array[*p_n5 - node_array_size].x;
	y2 = *new_node_class_array[*p_n5 - node_array_size].y;
	z2 = *new_node_class_array[*p_n5 - node_array_size].z;
}
else{
	x2 = *node_class_array[*p_n5].x;
	y2 = *node_class_array[*p_n5].y;
	z2 = *node_class_array[*p_n5].z;
}

x_dist = x1 - x2;
y_dist = y1 - y2;
z_dist = z1 - z2;
n2_n5_dist = x_dist*x_dist + y_dist*y_dist + z_dist*z_dist;

if (*p_n3 >= node_array_size){
	x1 = *new_node_class_array[*p_n3 - node_array_size].x;
	y1 = *new_node_class_array[*p_n3 - node_array_size].y;
	z1 = *new_node_class_array[*p_n3 - node_array_size].z;
}
else{
	x1 = *node_class_array[*p_n3].x;
	y1 = *node_class_array[*p_n3].y;
	z1 = *node_class_array[*p_n3].z;
}

if (*p_n4 >= node_array_size){
	x2 = *new_node_class_array[*p_n4 - node_array_size].x;
	y2 = *new_node_class_array[*p_n4 - node_array_size].y;
	z2 = *new_node_class_array[*p_n4 - node_array_size].z;
}
else{
	x2 = *node_class_array[*p_n4].x;
	y2 = *node_class_array[*p_n4].y;
	z2 = *node_class_array[*p_n4].z;
}

x_dist = x1 - x2;
y_dist = y1 - y2;
z_dist = z1 - z2;
n3_n4_dist = x_dist*x_dist + y_dist*y_dist + z_dist*z_dist;



if((n1_n6_dist < n2_n5_dist)&&(n1_n6_dist < n3_n4_dist)){


	if(param.use_lite == false){
		new_tet_class_array[t_num+4].new_tet(p_n1, p_n6, p_n2, p_n3, t_num+4, new_tet_array, have_red1, level_input);
		new_tet_class_array[t_num+5].new_tet(p_n1, p_n6, p_n2, p_n4, t_num+5, new_tet_array, have_red1, level_input);
		new_tet_class_array[t_num+6].new_tet(p_n1, p_n6, p_n4, p_n5, t_num+6, new_tet_array, have_red1, level_input);
		new_tet_class_array[t_num+7].new_tet(p_n1, p_n6, p_n3, p_n5, t_num+7, new_tet_array, have_red1, level_input);
	}else{
		param.tet_class_array_red5[t_num+4].new_tet_lite(p_n1,p_n6,p_n2,p_n3,t_num+4,new_tet_array);
		param.tet_class_array_red5[t_num+5].new_tet_lite(p_n1,p_n6,p_n2,p_n4,t_num+5,new_tet_array);
		param.tet_class_array_red5[t_num+6].new_tet_lite(p_n1,p_n6,p_n4,p_n5,t_num+6,new_tet_array);
		param.tet_class_array_red5[t_num+7].new_tet_lite(p_n1,p_n6,p_n3,p_n5,t_num+7,new_tet_array);

	}

};

if( (n2_n5_dist < n1_n6_dist)&&(n2_n5_dist < n3_n4_dist)){

	if(param.use_lite == false){
		new_tet_class_array[t_num+4].new_tet(p_n2, p_n5, p_n1, p_n3, t_num+4, new_tet_array, have_red1, level_input);
		new_tet_class_array[t_num+5].new_tet(p_n2, p_n5, p_n4, p_n6, t_num+5, new_tet_array, have_red1, level_input);
		new_tet_class_array[t_num+6].new_tet(p_n2, p_n5, p_n1, p_n4, t_num+6, new_tet_array, have_red1, level_input);
		new_tet_class_array[t_num+7].new_tet(p_n2, p_n5, p_n3, p_n6, t_num+7, new_tet_array, have_red1, level_input);
	}else{
		param.tet_class_array_red5[t_num+4].new_tet_lite(p_n2,p_n5,p_n1,p_n3,t_num+4,new_tet_array);
		param.tet_class_array_red5[t_num+5].new_tet_lite(p_n2,p_n5,p_n4,p_n6,t_num+5,new_tet_array);
		param.tet_class_array_red5[t_num+6].new_tet_lite(p_n2,p_n5,p_n1,p_n4,t_num+6,new_tet_array);
		param.tet_class_array_red5[t_num+7].new_tet_lite(p_n2,p_n5,p_n3,p_n6,t_num+7,new_tet_array);

	}

};

if((n3_n4_dist < n1_n6_dist)&&(n3_n4_dist < n2_n5_dist)){

	if(param.use_lite == false){
		new_tet_class_array[t_num+4].new_tet(p_n3, p_n4, p_n1, p_n2, t_num+4, new_tet_array, have_red1, level_input);
		new_tet_class_array[t_num+5].new_tet(p_n3, p_n4, p_n5, p_n6, t_num+5, new_tet_array, have_red1, level_input);
		new_tet_class_array[t_num+6].new_tet(p_n3, p_n4, p_n1, p_n5, t_num+6, new_tet_array, have_red1, level_input);
		new_tet_class_array[t_num+7].new_tet(p_n3, p_n4, p_n2, p_n6, t_num+7, new_tet_array, have_red1, level_input);
	}else{
		param.tet_class_array_red5[t_num+4].new_tet_lite(p_n3,p_n4,p_n1,p_n2,t_num+4,new_tet_array);
		param.tet_class_array_red5[t_num+5].new_tet_lite(p_n3,p_n4,p_n5,p_n6,t_num+5,new_tet_array);
		param.tet_class_array_red5[t_num+6].new_tet_lite(p_n3,p_n4,p_n1,p_n5,t_num+6,new_tet_array);
		param.tet_class_array_red5[t_num+7].new_tet_lite(p_n3,p_n4,p_n2,p_n6,t_num+7,new_tet_array);
	}


};




/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



		//if varies = n1-n6
		//5 : n1, n6, n2, n3 : 25,13,14,20,23,15 
		//6 : n1, n6, n2, n4 : 25,13,16,20,21,19
		//7 : n1, n6, n4, n5 : 25,16,17,21,24,18
		//8 : n1, n6, n3, n5 : 25,14,17,23,24,22

		//if varies = n2-n5
		//5: n2, n5, n1, n3 : 25,13,15,17,22,14 
		//6: n2, n5, n4, n6 : 25,19,20,18,24,21 
		//7: n2, n5, n1, n4 : 25,13,19,17,18,16 
		//8: n2, n5, n3, n6 : 25,15,20,22,24,23

		//if varies = n3-n4
		//5: n3, n4, n1, n2 : 25,14,15,16,19,13
		//6: n3, n4, n5, n6 : 25,22,23,18,21,24
		//7: n3, n4, n1, n5 : 25,14,22,16,18,17 
		//8: n3, n4, n2, n6 : 25,15,23,19,21,20


		tet_class_array[n].set_remove_true ();


		//only the tets that are suppose to be red refined are marked as remove false.  the tets to be green refined have 
		//red refined back ups just in case the green tets need to be removed and replaced with red tets later



		long red_tet_backup_input[8];

		if( (tet_class_array[n].tet_color == to_green1a) ||(tet_class_array[n].tet_color == to_green1b) || (tet_class_array[n].tet_color == to_green1c) ){

			if(param.use_lite == false){
			for(long u=0; u<8; u++){
				red_tet_backup_input[u] = t_num + u;
				new_tet_class_array[t_num + u].set_remove_true ();
			};
			}else{
			for(long u=0; u<8; u++){
				red_tet_backup_input[u] = t_num + u;
				param.tet_class_array_red5[t_num + u].set_remove_true ();
			}
			}
		
			tet_class_array[n].set_red_backup (red_tet_backup_input, new_tet_array);
			tet_class_array[n].set_remove_false ();

		};




		t_num = t_num + 8;


		};
		
	};

	

}


